//module:DATE_CNT 
//Ver 0.50
//date 20/01/2003
//Kenji Yokomizo <kyokomi@mvi.biglobe.ne.jp>
//

module  DATE_CNT (CLK,RST,ADR,DAT
                 //,SS_1,SS_2
                  );
input   CLK,RST;
input   [3:0]ADR;
output  [15:0]DAT;
//output  [3:0]SS_1; 
//output  [3:0]SS_2; 

reg [22:0]COUNT;
reg [6:0]MM;
reg [6:0]SS;
reg [5:0]HH;
reg [6:0]DD;
reg [3:0]MONTH;
reg [3:0]YY;
reg [2:0]WW;
wire MONTH_END;
wire [23:0]W_A;
wire [23:0]M_A;
//wire [3:0]SS_1;
//wire [3:0]SS_2;
parameter COUNT_MAX =23'd8191999; //CLK 8.192MHz
//parameter COUNT_MAX =23'd10000; 
parameter SS_MAX =7'h59; 
parameter MM_MAX =7'h59; 
parameter HH_MAX =6'h23; 
parameter MONTH_MAX =4'd12;
parameter YY_MAX =4'h9;

//assign SS_1 = SS[3:0];
//assign SS_2 = {1'b0,SS[6:4]};

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1) 
    begin
      COUNT <= 23'd0;
    end
  else
    begin
      if (COUNT == COUNT_MAX)
        begin
          COUNT <= 23'd0;
        end
      else
        begin
          COUNT <= COUNT+23'd1;
        end
    end
end

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1) 
    begin
      SS <= 7'd0;
      MM <= 7'd0;
      HH <= 6'd0;
      DD <= 6'd1;
      MONTH <= 4'd1;
      YY <= 4'h2;
      WW <= 3'h2;
    end
  else
    begin
      if (COUNT == COUNT_MAX)
        begin
          if (SS==SS_MAX)
            SS <= 7'd0;
          else
            SS <= BCD_ADD_7(SS);
          if (SS==SS_MAX)
            if (MM==MM_MAX)
              MM <= 6'd0;
            else
              MM <= BCD_ADD_7(MM);
          else
            MM <= MM;
          if ((SS==SS_MAX)&&(MM==MM_MAX))
            if (HH==HH_MAX)
              HH <= 5'd0;
            else
              HH <= BCD_ADD_6(HH);
          else
            HH <= HH;
          if ((SS==SS_MAX)&&(MM==MM_MAX)&&(HH==HH_MAX))
            begin
              if (M_END(MONTH,DD)==1'b1)
                DD <= 5'd1;
              else
                DD <= BCD_ADD_6(DD);
              if (WW==3'd6)
                WW <= 3'd0;
              else
                WW <= WW + 3'd1;
            end
          else
            begin
              DD <= DD;
              WW <= WW;
            end
          if ((SS==SS_MAX)&&(MM==MM_MAX)&&(HH==HH_MAX)&&(MONTH_END==1'b1))
            if (MONTH==MONTH_MAX)
              begin
                MONTH <= 4'd1;
                YY <= YY +4'd1;
              end
            else
              begin
                MONTH <= MONTH +4'd1;
                YY <= YY;
              end
          else
            begin
              MONTH <= MONTH ;
              YY <= YY ;
            end
        end
      else
        begin
          SS <= SS;
          MM <= MM;
          HH <= HH;
          DD <= DD;
          MONTH <= MONTH ;
        end
    end
end

assign MONTH_END = M_END(MONTH,DD);

function M_END;
  input [3:0]MONTH;
  input [5:0]DD;
  begin
    if ((((MONTH==4'd1)||(MONTH==4'd3)||(MONTH==4'd5)||(MONTH==4'd7)||(MONTH==4'd8)||(MONTH==4'd10)||(MONTH==4'd12))
         &&(DD==6'h31))
         ||
        (((MONTH==4'd04)||(MONTH==4'd6)||(MONTH==4'd9)||(MONTH==4'd11))
         &&(DD==6'h30))
         ||
        ((MONTH==4'd2)&&(DD==6'h28)))
      M_END =1'b1;
    else
      M_END =1'b0;
  end
endfunction


function [6:0]BCD_ADD_7;
  input [6:0]DATA;
  begin
    if (DATA[3:0]==4'h9)
      BCD_ADD_7 = {DATA[6:4]+4'b1,4'd0};
    else
      BCD_ADD_7 = {DATA[6:4],DATA[3:0]+4'd1};
  end
endfunction


function [5:0]BCD_ADD_6;
  input [5:0]DATA;
  begin
    if (DATA[3:0]==4'h9)
      BCD_ADD_6 = {DATA[5:4]+4'b1,4'd0};
    else
      BCD_ADD_6 = {DATA[5:4],DATA[3:0]+4'd1};
  end
endfunction
/*
function [4:0]BCD_ADD_5;
  input [4:0]DATA;
  begin
    if (DATA[3:0]==4'h9)
      BCD_ADD_5 = {DATA[4]+4'b1,4'd0};
    else
      BCD_ADD_5 = {DATA[4],DATA[3:0]+4'd1};
  end
endfunction
*/

assign W_A = (WW==3'd0)? 24'h53756e:
             (WW==3'd1)? 24'h4d6f6e:
             (WW==3'd2)? 24'h547565:
             (WW==3'd3)? 24'h576564:
             (WW==3'd4)? 24'h546875:
             (WW==3'd5)? 24'h467249:
             (WW==3'd6)? 24'h536174:
                         24'h202020; 

assign M_A = (MONTH==4'd1)? 24'h4a616e:
             (MONTH==4'd2)? 24'h466562:
             (MONTH==4'd3)? 24'h4d6172:
             (MONTH==4'd4)? 24'h417072:
             (MONTH==4'd5)? 24'h4d6179:
             (MONTH==4'd6)? 24'h4a756e: 
             (MONTH==4'd7)? 24'h4a756c: 
             (MONTH==4'd8)? 24'h417567: 
             (MONTH==4'd9)? 24'h536570: 
             (MONTH==4'd10)? 24'h4f6374: 
             (MONTH==4'd11)? 24'h4e6f76: 
             (MONTH==4'd12)? 24'h446563:
                             24'h202020;

assign DAT = DAT_GEN(ADR,SS,MM,HH,DD,YY,W_A,M_A);

function [15:0]DAT_GEN;
  input [3:0]ADR;
  input [7:0]SS;
  input [7:0]MM;
  input [7:0]HH;
  input [7:0]DD;
  input [7:0]YY;
  input [23:0]W_A;
  input [23:0]M_A;
  begin
    case (ADR)
      4'h0:DAT_GEN={  W_A[23:16],  8'h20};
      4'h1:DAT_GEN={  W_A[7:0],    W_A[15:8]};
      4'h2:DAT_GEN={  8'h20,        8'h2c};
      4'h3:DAT_GEN={  4'h3,DD[3:0], 4'h3,DD[7:4]};
      4'h4:DAT_GEN={  M_A[23:16],   8'h20};
      4'h5:DAT_GEN={  M_A[7:0],     M_A[15:8]};
      4'h6:DAT_GEN={  8'h32,        8'h20};
      4'h7:DAT_GEN={  4'h3,YY[7:4], 8'h30};
      4'h8:DAT_GEN={  8'h20,        4'h3,YY[3:0]};
      4'h9:DAT_GEN={  4'h3,HH[3:0], 4'h3,HH[7:4]};
      4'hA:DAT_GEN={  4'h3,MM[7:4], 8'h3A};
      4'hB:DAT_GEN={  8'h3A,        4'h3,MM[7:4]};
      4'hC:DAT_GEN={  4'h3,SS[7:4], 4'h3,SS[7:4]};   
      default:DAT_GEN={  8'h20,        8'h20};
    endcase
  end
endfunction


endmodule
