//module:ISA_SV  
//Ver 0.50
//date 20/01/2003
//Kenji Yokomizo <kyokomi@mvi.biglobe.ne.jp>

module  ISA_SV  ( CLK,XRST,RESET_DEV,XSMEMW,XSMEMR,XIOW,XIOR,ISA_CLK,BALE,AEN,SD,SA,XMEMR,XMEMW,XIOCHDRY,LED,LED_SEL,TCP_SW,DATA_OUT,DATA_OUT_EN,DATA_IN,DATA_IN_EN);
input   CLK; 
input   XRST; 
//output   DSR;
//output   RXD;
//input  DTR;
//input  TXD;
// ISA IF
output RESET_DEV;
output XSMEMW;
output XSMEMR;
output XIOW;
output XIOR;
output ISA_CLK;
output BALE;
input  XIOCHDRY;
output AEN;
inout  [15:0] SD;
output [19:0]SA;
//input  XIOCS6;
output XMEMR;
output XMEMW;
//
output [7:0]LED;
output[4:0] LED_SEL;
input TCP_SW;
output  DATA_OUT;
output  DATA_OUT_EN;
input   [7:0]DATA_IN;
input   DATA_IN_EN;

//
//input IRQ3;
//input IRQ4;
//input IRQ5;
//input IRQ7;
//input IRQ9;
//input IRQ10;
//input IRQ11;
//input IRQ12;
//
//wire SEND;
//wire [7:0] SEND_DT;
//wire RCV;
//wire [7:0] RCV_DT;
//wire S_BUSY;

wire START;
wire END;
wire [1:0] U_CMD;
wire [19:0] U_ADR;
wire [15:0] U_DI;
wire [15:0] U_DO;
wire RST;
wire [15:0]SD_I;
wire [15:0]SD_O;
wire SD_C;
wire U_BUSY;
wire [15:0]ST_DI;
wire [15:0]ST_DO;
wire ST_DI_EN;
wire ST_DI_BUSY;
wire ST_DO_EN;
wire ST_DO_BUSY; 
wire [7:0] STS_O; 
wire [7:0] STS_I;
wire DMA_END;
wire [15:0]DMA_MAX;

wire   [15:0]SOC_MAC1;
wire   [15:0]SOC_MAC2;
wire   [15:0]SOC_MAC3; 
wire   [15:0]SOC_IP1;  
wire   [15:0]SOC_IP2;

wire [7:0]PRC_LED;
//wire TCP_SW;
wire [3:0]HTTP_CNT1;
wire [3:0]HTTP_CNT2;

assign HTTP_CNT1 = DATA_IN[3:0];
assign HTTP_CNT2 = DATA_IN[7:4]; 

assign RST = ~XRST;
assign SD =(SD_C==1'b1)? SD_O:16'bZZZZZZZZZZZZZZZZ;
assign SD_I = SD;
assign LED = PRC_LED;

/*
DCE_IF DCE_IF_1 (
   .CLK(CLK)
  ,.RST(RST)
  ,.DSR(DSR)
  ,.RXD(RXD)
  ,.DTR(DTR)
  ,.TXD(TXD)
  ,.SEND(SEND)
  ,.SEND_DT(SEND_DT)
  ,.RCV(RCV)
  ,.RCV_DT(RCV_DT)
  ,.S_BUSY(S_BUSY)
  );
*/
//assign RCV= 1'b0;
//assign RCV_DT = 8'h00;
//assign S_BUSY =1'b0;

MINI_CPU CPU_1(
   .CLK(CLK)
  ,.RST(RST)
  //,.SEND(SEND)
  //,.SEND_DT(SEND_DT)
  //,.RCV(RCV)
  //,.RCV_DT(RCV_DT)
  ,.ST_DO(ST_DI)
  ,.ST_DO_EN(ST_DI_EN)
  ,.ST_DO_BUSY(ST_DI_BUSY)
  ,.ST_DI(ST_DO)
  ,.ST_DI_EN(ST_DO_EN)
  ,.ST_DI_BUSY(ST_DO_BUSY)
  ,.STS_I(STS_I)
  ,.STS_O(STS_O)
  ,.REG_M1(SOC_MAC1)
  ,.REG_M2(SOC_MAC2)
  ,.REG_M3(SOC_MAC3)
  ,.REG_M4(SOC_IP1)
  ,.REG_M5(SOC_IP2)
  ,.DMA_END(DMA_END)
  ,.DMA_MAX(DMA_MAX)
  //,.S_BUSY(S_BUSY)
  ,.U_START(START)
  ,.U_END(END)
  ,.U_CMD(U_CMD)
  ,.U_ADR(U_ADR)
  ,.U_DI(U_DO)
  ,.U_DO(U_DI)
  ,.U_BUSY(U_BUSY)
  ,.PRC_LED(PRC_LED)
  ,.LED_SEL(LED_SEL)
  ,.CLK_LED(CLK)
  ,.TCP_SW(TCP_SW)
  ,.HTTP_CNT1(HTTP_CNT1)
  ,.HTTP_CNT2(HTTP_CNT2)
  );

IP_EXT IP_EXT_1(
  .CLK(CLK)
  ,.RST(RST)
  ,.ST_DO(ST_DO)
  ,.ST_DO_EN(ST_DO_EN)
  ,.ST_DO_BUSY(ST_DO_BUSY)
  ,.ST_DI(ST_DI)
  ,.ST_DI_EN(ST_DI_EN)
  ,.ST_DI_BUSY(ST_DI_BUSY)
  ,.STS_I(STS_O)
  ,.STS_O(STS_I)
  ,.SOC_MAC1(SOC_MAC1)
  ,.SOC_MAC2(SOC_MAC2)
  ,.SOC_MAC3(SOC_MAC3)
  ,.SOC_IP1(SOC_IP1)
  ,.SOC_IP2(SOC_IP2)
  ,.DMA_END(DMA_END)
  ,.DMA_MAX(DMA_MAX)
  ,.DATA_IN(DATA_IN)
  ,.DATA_IN_EN(DATA_IN_EN)
  ,.DATA_OUT(DATA_OUT)
  ,.DATA_OUT_EN(DATA_OUT_EN)
  //,.SS_1(HTTP_CNT1)
  //,.SS_2(HTTP_CNT2)

  );


ISA_CTL ISA_CTL_1(
   .CLK(CLK)
  ,.RST(RST)
  ,.START(START)
  ,.END(END)
  ,.U_CMD(U_CMD)
  ,.U_ADR(U_ADR)
  ,.U_DI(U_DI)
  ,.U_DO(U_DO)
  ,.U_BUSY(U_BUSY)
  ,.RESET_DEV(RESET_DEV)
  ,.XSMEMW(XSMEMW)
  ,.XSMEMR(XSMEMR)
  ,.XIOW(XIOW)
  ,.XIOR(XIOR)
  ,.ISA_CLK(ISA_CLK)
  ,.BALE(BALE)
  ,.AEN(AEN)
  ,.SD_I(SD_I)
  ,.SD_O(SD_O)
  ,.SD_C(SD_C)
  ,.SA(SA)
  ,.XIOCS6(XIOCS6)
  ,.XMEMR(XMEMR)
  ,.XMEMW(XMEMW)
  ,.XIOCHDRY(XIOCHDRY)
  );

endmodule
