//module:c_rom
//Ver 0.50
//date 20/01/2003
//Kenji Yokomizo <kyokomi@mvi.biglobe.ne.jp>
//
module c_rom (
    A,
    SPO);

input [7 : 0] A;
output [15 : 0] SPO;
reg    [15 : 0] SPO;
always@(A)begin
  case(A)
//#  NIC-PLD ROM DATA 5/10
    8'd0:SPO=16'hd0ff;//r0 <-ff FPGA
    //8'd0:SPO=16'hd002;//r0 <-ff  sim
    8'd1:SPO=16'hc306;//rB <=0
    8'd2:SPO=16'hc2ff;//rA <=ff FPGA
    //8'd2:SPO=16'hc202;//rA <=ff sim
    8'd3:SPO=16'hf949;//rA <=rA-const_1
    8'd4:SPO=16'hfd48;//if rA=const_0 then jp(rB:06)
    8'd5:SPO=16'hc103;// jp(03)
    8'd6:SPO=16'hc30c;//rB = 0c
    8'd7:SPO=16'h4250;//rA <= f10
    8'd8:SPO=16'hf949;//rA <=rA-const_1
    8'd9:SPO=16'hfd48;//if rA=const_0 then jp(rB:0c)
    8'd10:SPO=16'h5042;//r10 <= rA
    8'd11:SPO=16'hc101;// jp(01)
//#  INITIAL
    8'd12:SPO=16'hc200;//rA = 00
    8'd13:SPO=16'h8000;//soft reset 
    8'd14:SPO=16'h9821;//CR set page0 stop
    8'd15:SPO=16'h8e19;//DCR set 
    8'd16:SPO=16'h8a00;//PBCRD0 set
    8'd17:SPO=16'h8b00;//PBCRD1 set 
    8'd18:SPO=16'h8f00;//IMR cll
    8'd19:SPO=16'h8d02;//TCR loop_bake
    8'd20:SPO=16'h8c20;//RCR monitor
    8'd21:SPO=16'h8146;//PSTART TCR set
    8'd22:SPO=16'h8280;//PSTOP set
    8'd23:SPO=16'h8346;//BNRY set
    8'd24:SPO=16'h8041;//CR set page1
    8'd25:SPO=16'h8747;//CURR set
//#// MAC ADR
    8'd26:SPO=16'h8021;//CR set page0
    8'd27:SPO=16'h8800;//RSAR0 set 0
    8'd28:SPO=16'h8900;//RSAR1 set 0
    8'd29:SPO=16'h8a0b;//RBCR0 set b
    8'd30:SPO=16'h8b00;//RBCR1 stt 0
    8'd31:SPO=16'h800a;//CR set page0 r_read
    8'd32:SPO=16'h5010;//reg_0(L) <= MAC0
    8'd33:SPO=16'h5110;//reg_0(M) <= MAC1
    8'd34:SPO=16'h5210;//reg_1(L) <= MAC2
    8'd35:SPO=16'h5310;//reg_1(M) <= MAC3
    8'd36:SPO=16'h5410;//reg_2(L) <= MAC4
    8'd37:SPO=16'h5510;//reg_3(M) <= MAC5
    8'd38:SPO=16'h8041;//CR set page1 stop
    8'd39:SPO=16'h0150;//set MAC0
    8'd40:SPO=16'h0251;//set MAC1
    8'd41:SPO=16'h0352;//set MAC2
    8'd42:SPO=16'h0453;//set MAC3
    8'd43:SPO=16'h0554;//set MAC4
    8'd44:SPO=16'h0655;//set MAC5
    8'd45:SPO=16'hd6c0;//set IP 192 ***
    8'd46:SPO=16'hd7a8;//set IP 168 ***
    8'd47:SPO=16'hd800;//set IP   0 ***
    8'd48:SPO=16'hd96b;//set IP 107 ***
//#      // NIC START
    8'd49:SPO=16'h8021;//CR set page0 stop
    8'd50:SPO=16'h8d00;//TCR set 00
    8'd51:SPO=16'h8c0f;//RCR set 0f
    8'd52:SPO=16'h800a;//CR set page0 r_read
//#      // RCV CHK
    8'd53:SPO=16'hc335;// rB(35)
    8'd54:SPO=16'h420c;// rA<-RSR
    8'd55:SPO=16'hfa49;// rA<-rA & cont_01
    8'd56:SPO=16'hfd48;//if rA=const_0 then jp(rB:35)
//#      // CURR
    8'd57:SPO=16'hc336;// rb(36)
    8'd58:SPO=16'h804a;// page1
    //8'd59:SPO=16'h6007;// r10<-CURR
    8'd59:SPO=16'h5C07;// rC<-CURR
    8'd60:SPO=16'h800a;// page0
    8'd61:SPO=16'h4203;// rA<-BURR
    8'd62:SPO=16'hf849;// rA<-rA+const_1 
    //8'd63:SPO=16'h6142;// r11 <-rA
    8'd63:SPO=16'h5d42;// rD <-rA
   // 8'd64:SPO=16'hf960;// a<-rA-rC (BURR+1)-CURR
    8'd64:SPO=16'hf95C;// a<-rA-rC (BURR+1)-CURR
    8'd65:SPO=16'hfd48;// if rA==0 then jp(rB:36) else next
    8'd66:SPO=16'h8021;// CR stop
//# DMA r1
    8'd67:SPO=16'h8800;//RSAR0 set 0
    //8'd68:SPO=16'h0961;//RSAR1 set BURRY1
    8'd68:SPO=16'h095d;//RSAR1 set BURRY1
    8'd69:SPO=16'h8a04;//RBCR0 set 4
    8'd70:SPO=16'h8b00;//RBCR1 set 0
    8'd71:SPO=16'h800a;// CR r read
    //8'd72:SPO=16'h7e10;// DMA_R NP RS
    8'd72:SPO=16'h7710;// DMA_R NP RS  
    //8'd73:SPO=16'h7910;// COUNT_R
    8'd73:SPO=16'h7510;// COUNT_R
    8'd74:SPO=16'h8021;// CR stop
    8'd75:SPO=16'h8804;//RSAR0 set 4
    //8'd76:SPO=16'h0961;//RSAR1 set BNRRY
    //8'd77:SPO=16'h0a62;//RBCR0 set COUNT_R_L
    //8'd78:SPO=16'h0b63;//RBCR1 set COUNT_R_H
    8'd76:SPO=16'h095d;//RSAR1 set BNRRY
    8'd77:SPO=16'h0a5a;//RBCR0 set COUNT_R_L
    8'd78:SPO=16'h0b5b;//RBCR1 set COUNT_R_H
    8'd79:SPO=16'h800a;// CR r read
//# DMA r2
    8'd80:SPO=16'hc357;//rB<-57
    8'd81:SPO=16'hC501;//ST_O<-start_code(01)
//    8'd82:SPO=16'hc200;//rA<-00
//    8'd82:SPO=16'h4d79;//DMA_MAX <-COUNT_R
    8'd82:SPO=16'h4d75;//DMA_MAX <-COUNT_R
    8'd83:SPO=16'h4710;//ST_DO<-DMA
//    8'd84:SPO=16'hf84a;//rA <- rA + const_2 
//    8'd85:SPO=16'hfe63;//if rA > r13(count_r) then jp(rB:57) 
//    8'd86:SPO=16'hc153;//jp(53)
    8'd84:SPO=16'hc200;
    8'd85:SPO=16'hc200;
    8'd86:SPO=16'hc200;
    8'd87:SPO=16'hC500;//ST_O <- en
//    8'd88:SPO=16'h426d;//rA <- NP 
    8'd88:SPO=16'h425f;//rA <- NP 
    8'd89:SPO=16'hf949;//rA <- rA(NP)-1
    8'd90:SPO=16'h0342;//BURR <- rA(NP-1)
//# SEND CHK
    8'd91:SPO=16'hc335;//rB<-35 *
    8'd92:SPO=16'h4244;//rA<-ST_I    
    8'd93:SPO=16'hfd48;//if rA(ST_I)==const_0 then jp(rB:35) 
//# SEND DMA 1
    8'd94:SPO=16'h8021;//CR set page0 read
    8'd95:SPO=16'h0846;//RSAR0 set
    8'd96:SPO=16'h0946;//RSAR1 set
    //8'd97:SPO=16'h7746;//r16_8 <-tx_byte
    8'd97:SPO=16'h7546;//r16_8 <-tx_byte
    //8'd98:SPO=16'h0a5e;//RBCR0 set 
    8'd98:SPO=16'h0a5a;//RBCR0 set 
    8'd99:SPO=16'h0b46;//RBCR1 set 
    8'd100:SPO=16'h8012;//CR set r_write
//# SEND DMA 2
    8'd101:SPO=16'hc36A;//rB<-6A *
    8'd102:SPO=16'h4244;//rA<-STS_I
    8'd103:SPO=16'hfd48;//if rA==const_0 then jp(rB:6A) else next
    8'd104:SPO=16'h1046;// DMA <- ST_DI 
    8'd105:SPO=16'hc166;//jp(rC:66)
    8'd106:SPO=16'h8440;//TPSR  40
    //8'd107:SPO=16'h055e;//TBCR0 <- tx_byte(L)
    //8'd108:SPO=16'h065f;//TBCR1 <- tx_byte(M)
    8'd107:SPO=16'h055a;//TBCR0 <- tx_byte(L)
    8'd108:SPO=16'h065b;//TBCR1 <- tx_byte(M)
    8'd109:SPO=16'h800e;//CR set r_read tx
    8'd110:SPO=16'hc204;//rA <= adr 04h
//# SEND CHK 
    8'd111:SPO=16'hc370;//rB<-70 *
    8'd112:SPO=16'h4204;// rA<-RSR
    8'd113:SPO=16'hfa49;// rA<-rA & cont_01
    8'd114:SPO=16'hfd48;//if rA=const_0 then jp(rB:70)
    8'd115:SPO=16'hc15b;//jp 5b
    8'd116:SPO=16'hffff;
    8'd117:SPO=16'hffff;
    8'd118:SPO=16'hffff;
    8'd119:SPO=16'hffff;
    8'd120:SPO=16'hffff;
    8'd121:SPO=16'hffff;
    8'd122:SPO=16'hffff;
    8'd123:SPO=16'hffff;
    8'd124:SPO=16'hffff;
    8'd125:SPO=16'hffff;
    8'd126:SPO=16'hffff;
    8'd127:SPO=16'hffff;
    8'd128:SPO=16'hffff;
    8'd129:SPO=16'hffff;
    8'd130:SPO=16'hffff;
    8'd131:SPO=16'hffff;
    8'd132:SPO=16'hffff;
    8'd133:SPO=16'hffff;
    8'd134:SPO=16'hffff;
    8'd135:SPO=16'hffff;
    8'd136:SPO=16'hffff;
    8'd137:SPO=16'hffff;
    8'd138:SPO=16'hffff;
    8'd139:SPO=16'hffff;
    8'd140:SPO=16'hffff;
    8'd141:SPO=16'hffff;
    8'd142:SPO=16'hffff;
    8'd143:SPO=16'hffff;
    8'd144:SPO=16'hffff;
    8'd145:SPO=16'hffff;
    8'd146:SPO=16'hffff;
    8'd147:SPO=16'hffff;
    8'd148:SPO=16'hffff;
    8'd149:SPO=16'hffff;
    8'd150:SPO=16'hffff;
    8'd151:SPO=16'hffff;
    8'd152:SPO=16'hffff;
    8'd153:SPO=16'hffff;
    8'd154:SPO=16'hffff;
    8'd155:SPO=16'hffff;
    8'd156:SPO=16'hffff;
    8'd157:SPO=16'hffff;
    8'd158:SPO=16'hffff;
    8'd159:SPO=16'hffff;
    8'd160:SPO=16'hffff;
    8'd161:SPO=16'hffff;
    8'd162:SPO=16'hffff;
    8'd163:SPO=16'hffff;
    8'd164:SPO=16'hffff;
    8'd165:SPO=16'hffff;
    8'd166:SPO=16'hffff;
    8'd167:SPO=16'hffff;
    8'd168:SPO=16'hffff;
    8'd169:SPO=16'hffff;
    8'd170:SPO=16'hffff;
    8'd171:SPO=16'hffff;
    8'd172:SPO=16'hffff;
    8'd173:SPO=16'hffff;
    8'd174:SPO=16'hffff;
    8'd175:SPO=16'hffff;
    8'd176:SPO=16'hffff;
    8'd177:SPO=16'hffff;
    8'd178:SPO=16'hffff;
    8'd179:SPO=16'hffff;
    8'd180:SPO=16'hffff;
    8'd181:SPO=16'hffff;
    8'd182:SPO=16'hffff;
    8'd183:SPO=16'hffff;
    8'd184:SPO=16'hffff;
    8'd185:SPO=16'hffff;
    8'd186:SPO=16'hffff;
    8'd187:SPO=16'hffff;
    8'd188:SPO=16'hffff;
    8'd189:SPO=16'hffff;
    8'd190:SPO=16'hffff;
    8'd191:SPO=16'hffff;
    8'd192:SPO=16'hffff;
    8'd193:SPO=16'hffff;
    8'd194:SPO=16'hffff;
    8'd195:SPO=16'hffff;
    8'd196:SPO=16'hffff;
    8'd197:SPO=16'hffff;
    8'd198:SPO=16'hffff;
    8'd199:SPO=16'hffff;
    8'd200:SPO=16'hffff;
    8'd201:SPO=16'hffff;
    8'd202:SPO=16'hffff;
    8'd203:SPO=16'hffff;
    8'd204:SPO=16'hffff;
    8'd205:SPO=16'hffff;
    8'd206:SPO=16'hffff;
    8'd207:SPO=16'hffff;
    8'd208:SPO=16'hffff;
    8'd209:SPO=16'hffff;
    8'd210:SPO=16'hffff;
    8'd211:SPO=16'hffff;
    8'd212:SPO=16'hffff;
    8'd213:SPO=16'hffff;
    8'd214:SPO=16'hffff;
    8'd215:SPO=16'hffff;
    8'd216:SPO=16'hffff;
    8'd217:SPO=16'hffff;
    8'd218:SPO=16'hffff;
    8'd219:SPO=16'hffff;
    8'd220:SPO=16'hffff;
    8'd221:SPO=16'hffff;
    8'd222:SPO=16'hffff;
    8'd223:SPO=16'hffff;
    8'd224:SPO=16'hffff;
    8'd225:SPO=16'hffff;
    8'd226:SPO=16'hffff;
    8'd227:SPO=16'hffff;
    8'd228:SPO=16'hffff;
    8'd229:SPO=16'hffff;
    8'd230:SPO=16'hffff;
    8'd231:SPO=16'hffff;
    8'd232:SPO=16'hffff;
    8'd233:SPO=16'hffff;
    8'd234:SPO=16'hffff;
    8'd235:SPO=16'hffff;
    8'd236:SPO=16'hffff;
    8'd237:SPO=16'hffff;
    8'd238:SPO=16'hffff;
    8'd239:SPO=16'hffff;
    8'd240:SPO=16'hffff;
    8'd241:SPO=16'hffff;
    8'd242:SPO=16'hffff;
    8'd243:SPO=16'hffff;
    8'd244:SPO=16'hffff;
    8'd245:SPO=16'hffff;
    8'd246:SPO=16'hffff;
    8'd247:SPO=16'hffff;
    8'd248:SPO=16'hffff;
    8'd249:SPO=16'hffff;
    8'd250:SPO=16'hffff;
    8'd251:SPO=16'hffff;
    8'd252:SPO=16'hffff;
    8'd253:SPO=16'hffff;
    8'd254:SPO=16'hffff;
    8'd255:SPO=16'hffff;  endcase
end
endmodule
