//module:http_rom 
//Ver 0.50
//date 20/01/2003
//Kenji Yokomizo <kyokomi@mvi.biglobe.ne.jp>
//

module http_rom (
    A,
    IP_DAT);

input [7 : 0] A;
output [15 : 0] IP_DAT;
reg    [15 : 0] IP_DAT;
always@(A)begin
  case(A)
    8'h0:IP_DAT<={8'h54,8'h48};//HT	dat=4854 chksum=4854
    8'h1:IP_DAT<={8'h50,8'h54};//TP	dat=5450 chksum=9ca4
    8'h2:IP_DAT<={8'h31,8'h2f};///1	dat=2f31 chksum=cbd5
    8'h3:IP_DAT<={8'h30,8'h2e};//.0	dat=2e30 chksum=fa05
    8'h4:IP_DAT<={8'h32,8'h20};// 2	dat=2032 chksum=11a37
    8'h5:IP_DAT<={8'h30,8'h30};//00	dat=3030 chksum=14a67
    8'h6:IP_DAT<={8'h4f,8'h20};// O	dat=204f chksum=16ab6
    8'h7:IP_DAT<={8'hd,8'h4b};//K		dat=4b d chksum=1b5c3
    8'h8:IP_DAT<={8'h44,8'ha};//[RE]D	dat= a44 chksum=1c007
    8'h9:IP_DAT<={8'h74,8'h61};//at	dat=6174 chksum=2217b
    8'ha:IP_DAT<={8'h3a,8'h65};//e:	dat=653a chksum=286b5
    8'hb:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=286b5
    8'hc:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=286b5
    8'hd:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=286b5
    8'he:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=286b5
    8'hf:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=286b5
    8'h10:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=286b5
    8'h11:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=286b5
    8'h12:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=286b5
    8'h13:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=286b5
    8'h14:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=286b5
    8'h15:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=286b5
    8'h16:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=286b5
    8'h17:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=286b5
    8'h18:IP_DAT<={8'h47,8'h20};// G	dat=2047 chksum=2a6fc
    8'h19:IP_DAT<={8'h54,8'h4d};//MT	dat=4d54 chksum=2f450
    8'h1a:IP_DAT<={8'ha,8'hd};//[RE]	dat= d a chksum=3015a
    8'h1b:IP_DAT<={8'h65,8'h53};//Se	dat=5365 chksum=354bf
    8'h1c:IP_DAT<={8'h76,8'h72};//rv	dat=7276 chksum=3c735
    8'h1d:IP_DAT<={8'h72,8'h65};//er	dat=6572 chksum=42ca7
    8'h1e:IP_DAT<={8'h20,8'h3a};//: 	dat=3a20 chksum=466c7
    8'h1f:IP_DAT<={8'h73,8'h59};//Ys	dat=5973 chksum=4c03a
    8'h20:IP_DAT<={8'hd,8'h76};//v		dat=76 d chksum=53647
    8'h21:IP_DAT<={8'h4c,8'ha};//[RE]L	dat= a4c chksum=54093
    8'h22:IP_DAT<={8'h73,8'h61};//as	dat=6173 chksum=5a206
    8'h23:IP_DAT<={8'h2d,8'h74};//t-	dat=742d chksum=61633
    8'h24:IP_DAT<={8'h6f,8'h4d};//Mo	dat=4d6f chksum=663a2
    8'h25:IP_DAT<={8'h69,8'h64};//di	dat=6469 chksum=6c80b
    8'h26:IP_DAT<={8'h69,8'h66};//fi	dat=6669 chksum=72e74
    8'h27:IP_DAT<={8'h64,8'h65};//ed	dat=6564 chksum=793d8
    8'h28:IP_DAT<={8'h20,8'h3a};//: 	dat=3a20 chksum=7cdf8
    8'h29:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=7cdf8
    8'h2a:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=7cdf8
    8'h2b:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=7cdf8
    8'h2c:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=7cdf8
    8'h2d:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=7cdf8
    8'h2e:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=7cdf8
    8'h2f:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=7cdf8
    8'h30:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=7cdf8
    8'h31:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=7cdf8
    8'h32:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=7cdf8
    8'h33:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=7cdf8
    8'h34:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=7cdf8
    8'h35:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=7cdf8
    8'h36:IP_DAT<={8'h47,8'h20};// G	dat=2047 chksum=7ee3f
    8'h37:IP_DAT<={8'h54,8'h4d};//MT	dat=4d54 chksum=83b93
    8'h38:IP_DAT<={8'ha,8'hd};//[RE]	dat= d a chksum=8489d
    8'h39:IP_DAT<={8'h6f,8'h43};//Co	dat=436f chksum=88c0c
    8'h3a:IP_DAT<={8'h74,8'h6e};//nt	dat=6e74 chksum=8fa80
    8'h3b:IP_DAT<={8'h6e,8'h65};//en	dat=656e chksum=95fee
    8'h3c:IP_DAT<={8'h2d,8'h74};//t-	dat=742d chksum=9d41b
    8'h3d:IP_DAT<={8'h65,8'h4c};//Le	dat=4c65 chksum=a2080
    8'h3e:IP_DAT<={8'h67,8'h6e};//ng	dat=6e67 chksum=a8ee7
    8'h3f:IP_DAT<={8'h74,8'h68};//ht	dat=6874 chksum=af75b
    8'h40:IP_DAT<={8'h20,8'h3a};//: 	dat=3a20 chksum=b317b
    8'h41:IP_DAT<={8'h31,8'h32};//21	dat=3231 chksum=b63ac
    8'h42:IP_DAT<={8'hd,8'h34};//4		dat=34 d chksum=b97b9
    8'h43:IP_DAT<={8'h43,8'ha};//[RE]C	dat= a43 chksum=ba1fc
    8'h44:IP_DAT<={8'h6e,8'h6f};//on	dat=6f6e chksum=c116a
    8'h45:IP_DAT<={8'h65,8'h6e};//ne	dat=6e65 chksum=c7fcf
    8'h46:IP_DAT<={8'h74,8'h63};//ct	dat=6374 chksum=ce343
    8'h47:IP_DAT<={8'h6f,8'h69};//io	dat=696f chksum=d4cb2
    8'h48:IP_DAT<={8'h3a,8'h6e};//n:	dat=6e3a chksum=dbaec
    8'h49:IP_DAT<={8'h6c,8'h63};//cl	dat=636c chksum=e1e58
    8'h4a:IP_DAT<={8'h73,8'h6f};//os	dat=6f73 chksum=e8dcb
    8'h4b:IP_DAT<={8'hd,8'h65};//e		dat=65 d chksum=ef2d8
    8'h4c:IP_DAT<={8'h43,8'ha};//[RE]C	dat= a43 chksum=efd1b
    8'h4d:IP_DAT<={8'h6e,8'h6f};//on	dat=6f6e chksum=f6c89
    8'h4e:IP_DAT<={8'h65,8'h74};//te	dat=7465 chksum=fe0ee
    8'h4f:IP_DAT<={8'h74,8'h6e};//nt	dat=6e74 chksum=104f62
    8'h50:IP_DAT<={8'h54,8'h2d};//-T	dat=2d54 chksum=107cb6
    8'h51:IP_DAT<={8'h70,8'h79};//yp	dat=7970 chksum=10f626
    8'h52:IP_DAT<={8'h3a,8'h65};//e:	dat=653a chksum=115b60
    8'h53:IP_DAT<={8'h74,8'h20};// t	dat=2074 chksum=117bd4
    8'h54:IP_DAT<={8'h78,8'h65};//ex	dat=6578 chksum=11e14c
    8'h55:IP_DAT<={8'h2f,8'h74};//t/	dat=742f chksum=12557b
    8'h56:IP_DAT<={8'h74,8'h68};//ht	dat=6874 chksum=12bdef
    8'h57:IP_DAT<={8'h6c,8'h6d};//ml	dat=6d6c chksum=132b5b
    8'h58:IP_DAT<={8'ha,8'hd};//	[RE]	dat= d a chksum=133865
    8'h59:IP_DAT<={8'ha,8'hd};//[RE]	dat= d a chksum=13456f
    8'h5a:IP_DAT<={8'h48,8'h3c};//<H	dat=3c48 chksum=1381b7
    8'h5b:IP_DAT<={8'h4d,8'h54};//TM	dat=544d chksum=13d604
    8'h5c:IP_DAT<={8'h3e,8'h4c};//L>	dat=4c3e chksum=142242
    8'h5d:IP_DAT<={8'ha,8'hd};//[RE]	dat= d a chksum=142f4c
    8'h5e:IP_DAT<={8'h42,8'h3c};//<B	dat=3c42 chksum=146b8e
    8'h5f:IP_DAT<={8'h44,8'h4f};//OD	dat=4f44 chksum=14bad2
    8'h60:IP_DAT<={8'h3e,8'h59};//Y>	dat=593e chksum=151410
    8'h61:IP_DAT<={8'ha,8'hd};//[RE]	dat= d a chksum=15211a
    8'h62:IP_DAT<={8'h50,8'h3c};//<P	dat=3c50 chksum=155d6a
    8'h63:IP_DAT<={8'h50,8'h3e};//>P	dat=3e50 chksum=159bba
    8'h64:IP_DAT<={8'h44,8'h4c};//LD	dat=4c44 chksum=15e7fe
    8'h65:IP_DAT<={8'h48,8'h5f};//_H	dat=5f48 chksum=164746
    8'h66:IP_DAT<={8'h54,8'h54};//TT	dat=5454 chksum=169b9a
    8'h67:IP_DAT<={8'h20,8'h50};//P 	dat=5020 chksum=16ebba
    8'h68:IP_DAT<={8'h6f,8'h63};//co	dat=636f chksum=174f29
    8'h69:IP_DAT<={8'h6e,8'h75};//un	dat=756e chksum=17c497
    8'h6a:IP_DAT<={8'h3d,8'h74};//t=	dat=743d chksum=1838d4
    8'h6b:IP_DAT<={8'h20,8'h20};//  	dat=2020 chksum=1838d4
    8'h6c:IP_DAT<={8'h2f,8'h3c};//</	dat=3c2f chksum=187503
    8'h6d:IP_DAT<={8'h3e,8'h50};//P>	dat=503e chksum=18c541
    8'h6e:IP_DAT<={8'ha,8'hd};//[RE]	dat= d a chksum=18d24b
    8'h6f:IP_DAT<={8'h46,8'h3c};//<F	dat=3c46 chksum=190e91
    8'h70:IP_DAT<={8'h52,8'h4f};//OR	dat=4f52 chksum=195de3
    8'h71:IP_DAT<={8'h20,8'h4d};//M 	dat=4d20 chksum=19ab03
    8'h72:IP_DAT<={8'h45,8'h4d};//ME	dat=4d45 chksum=19f848
    8'h73:IP_DAT<={8'h48,8'h54};//TH	dat=5448 chksum=1a4c90
    8'h74:IP_DAT<={8'h44,8'h4f};//OD	dat=4f44 chksum=1a9bd4
    8'h75:IP_DAT<={8'h22,8'h3d};//="	dat=3d22 chksum=1ad8f6
    8'h76:IP_DAT<={8'h45,8'h47};//GE	dat=4745 chksum=1b203b
    8'h77:IP_DAT<={8'h22,8'h54};//T"	dat=5422 chksum=1b745d
    8'h78:IP_DAT<={8'h41,8'h20};// A	dat=2041 chksum=1b949e
    8'h79:IP_DAT<={8'h54,8'h43};//CT	dat=4354 chksum=1bd7f2
    8'h7a:IP_DAT<={8'h4f,8'h49};//IO	dat=494f chksum=1c2141
    8'h7b:IP_DAT<={8'h3d,8'h4e};//N=	dat=4e3d chksum=1c6f7e
    8'h7c:IP_DAT<={8'h61,8'h22};//"a	dat=2261 chksum=1c91df
    8'h7d:IP_DAT<={8'h74,8'h63};//ct	dat=6374 chksum=1cf553
    8'h7e:IP_DAT<={8'h3e,8'h22};//">	dat=223e chksum=1d1791
    8'h7f:IP_DAT<={8'ha,8'hd};//[RE]	dat= d a chksum=1d249b
    8'h80:IP_DAT<={8'h49,8'h3c};//<I	dat=3c49 chksum=1d60e4
    8'h81:IP_DAT<={8'h50,8'h4e};//NP	dat=4e50 chksum=1daf34
    8'h82:IP_DAT<={8'h54,8'h55};//UT	dat=5554 chksum=1e0488
    8'h83:IP_DAT<={8'h54,8'h20};// T	dat=2054 chksum=1e24dc
    8'h84:IP_DAT<={8'h50,8'h59};//YP	dat=5950 chksum=1e7e2c
    8'h85:IP_DAT<={8'h3d,8'h45};//E=	dat=453d chksum=1ec369
    8'h86:IP_DAT<={8'h72,8'h22};//"r	dat=2272 chksum=1ee5db
    8'h87:IP_DAT<={8'h64,8'h61};//ad	dat=6164 chksum=1f473f
    8'h88:IP_DAT<={8'h6f,8'h69};//io	dat=696f chksum=1fb0ae
    8'h89:IP_DAT<={8'h20,8'h22};//" 	dat=2220 chksum=1fd2ce
    8'h8a:IP_DAT<={8'h41,8'h4e};//NA	dat=4e41 chksum=20210f
    8'h8b:IP_DAT<={8'h45,8'h4d};//ME	dat=4d45 chksum=206e54
    8'h8c:IP_DAT<={8'h22,8'h3d};//="	dat=3d22 chksum=20ab76
    8'h8d:IP_DAT<={8'h22,8'h63};//c"	dat=6322 chksum=210e98
    8'h8e:IP_DAT<={8'h56,8'h20};// V	dat=2056 chksum=212eee
    8'h8f:IP_DAT<={8'h4c,8'h41};//AL	dat=414c chksum=21703a
    8'h90:IP_DAT<={8'h45,8'h55};//UE	dat=5545 chksum=21c57f
    8'h91:IP_DAT<={8'h22,8'h3d};//="	dat=3d22 chksum=2202a1
    8'h92:IP_DAT<={8'h22,8'h31};//1"	dat=3122 chksum=2233c3
    8'h93:IP_DAT<={8'h3e,8'h20};// >	dat=203e chksum=225401
    8'h94:IP_DAT<={8'h4e,8'h4f};//ON	dat=4f4e chksum=22a34f
    8'h95:IP_DAT<={8'ha,8'hd};//[RE]	dat= d a chksum=22b059
    8'h96:IP_DAT<={8'h49,8'h3c};//<I	dat=3c49 chksum=22eca2
    8'h97:IP_DAT<={8'h50,8'h4e};//NP	dat=4e50 chksum=233af2
    8'h98:IP_DAT<={8'h54,8'h55};//UT	dat=5554 chksum=239046
    8'h99:IP_DAT<={8'h54,8'h20};// T	dat=2054 chksum=23b09a
    8'h9a:IP_DAT<={8'h50,8'h59};//YP	dat=5950 chksum=2409ea
    8'h9b:IP_DAT<={8'h3d,8'h45};//E=	dat=453d chksum=244f27
    8'h9c:IP_DAT<={8'h72,8'h22};//"r	dat=2272 chksum=247199
    8'h9d:IP_DAT<={8'h64,8'h61};//ad	dat=6164 chksum=24d2fd
    8'h9e:IP_DAT<={8'h6f,8'h69};//io	dat=696f chksum=253c6c
    8'h9f:IP_DAT<={8'h20,8'h22};//" 	dat=2220 chksum=255e8c
    8'ha0:IP_DAT<={8'h41,8'h4e};//NA	dat=4e41 chksum=25accd
    8'ha1:IP_DAT<={8'h45,8'h4d};//ME	dat=4d45 chksum=25fa12
    8'ha2:IP_DAT<={8'h22,8'h3d};//="	dat=3d22 chksum=263734
    8'ha3:IP_DAT<={8'h22,8'h63};//c"	dat=6322 chksum=269a56
    8'ha4:IP_DAT<={8'h56,8'h20};// V	dat=2056 chksum=26baac
    8'ha5:IP_DAT<={8'h4c,8'h41};//AL	dat=414c chksum=26fbf8
    8'ha6:IP_DAT<={8'h45,8'h55};//UE	dat=5545 chksum=27513d
    8'ha7:IP_DAT<={8'h22,8'h3d};//="	dat=3d22 chksum=278e5f
    8'ha8:IP_DAT<={8'h22,8'h30};//0"	dat=3022 chksum=27be81
    8'ha9:IP_DAT<={8'h3e,8'h20};// >	dat=203e chksum=27debf
    8'haa:IP_DAT<={8'h46,8'h4f};//OF	dat=4f46 chksum=282e05
    8'hab:IP_DAT<={8'hd,8'h46};//F		dat=46 d chksum=287412
    8'hac:IP_DAT<={8'h3c,8'ha};//[RE]<	dat= a3c chksum=287e4e
    8'had:IP_DAT<={8'h4e,8'h49};//IN	dat=494e chksum=28c79c
    8'hae:IP_DAT<={8'h55,8'h50};//PU	dat=5055 chksum=2917f1
    8'haf:IP_DAT<={8'h20,8'h54};//T 	dat=5420 chksum=296c11
    8'hb0:IP_DAT<={8'h59,8'h54};//TY	dat=5459 chksum=29c06a
    8'hb1:IP_DAT<={8'h45,8'h50};//PE	dat=5045 chksum=2a10af
    8'hb2:IP_DAT<={8'h22,8'h3d};//="	dat=3d22 chksum=2a4dd1
    8'hb3:IP_DAT<={8'h55,8'h53};//SU	dat=5355 chksum=2aa126
    8'hb4:IP_DAT<={8'h4d,8'h42};//BM	dat=424d chksum=2ae373
    8'hb5:IP_DAT<={8'h54,8'h49};//IT	dat=4954 chksum=2b2cc7
    8'hb6:IP_DAT<={8'h20,8'h22};//" 	dat=2220 chksum=2b4ee7
    8'hb7:IP_DAT<={8'hd,8'h3e};//>		dat=3e d chksum=2b8cf4
    8'hb8:IP_DAT<={8'h3c,8'ha};//[RE]<	dat= a3c chksum=2b9730
    8'hb9:IP_DAT<={8'h46,8'h2f};///F	dat=2f46 chksum=2bc676
    8'hba:IP_DAT<={8'h52,8'h4f};//OR	dat=4f52 chksum=2c15c8
    8'hbb:IP_DAT<={8'h3e,8'h4d};//M>	dat=4d3e chksum=2c6306
    8'hbc:IP_DAT<={8'ha,8'hd};//[RE]	dat= d a chksum=2c7010
    8'hbd:IP_DAT<={8'h2f,8'h3c};//</	dat=3c2f chksum=2cac3f
    8'hbe:IP_DAT<={8'h4f,8'h42};//BO	dat=424f chksum=2cee8e
    8'hbf:IP_DAT<={8'h59,8'h44};//DY	dat=4459 chksum=2d32e7
    8'hc0:IP_DAT<={8'hd,8'h3e};//>		dat=3e d chksum=2d70f4
    8'hc1:IP_DAT<={8'h3c,8'ha};//[RE]<	dat= a3c chksum=2d7b30
    8'hc2:IP_DAT<={8'h48,8'h2f};///H	dat=2f48 chksum=2daa78
    8'hc3:IP_DAT<={8'h4d,8'h54};//TM	dat=544d chksum=2dfec5
    8'hc4:IP_DAT<={8'h3e,8'h4c};//L>	dat=4c3e chksum=2e4b03
    8'hc5:IP_DAT<={8'ha,8'hd};//[RE]	dat= d a chksum=2e580d->583b
    //8'h8f:IP_DAT<={8'h30,8'h30};//00	dat=3030 chksum=1605f0->0606
    default:IP_DAT<=16'h0000;
  endcase
end
endmodule

