//module:IP_EXT 
//Ver 0.50
//date 20/01/2003
//Kenji Yokomizo <kyokomi@mvi.biglobe.ne.jp>
//

module  IP_EXT (CLK,RST,ST_DO,ST_DO_EN,ST_DO_BUSY,ST_DI,ST_DI_EN,ST_DI_BUSY,STS_I,STS_O
               ,SOC_MAC1,SOC_MAC2,SOC_MAC3,SOC_IP1,SOC_IP2
               ,DMA_END,DMA_MAX,DATA_OUT,DATA_OUT_EN,DATA_IN,DATA_IN_EN
               //,SS_1,SS_2
               );

input   CLK,RST;
input   [15:0]ST_DI;
input   ST_DI_EN;
output  ST_DI_BUSY;
output  [15:0]ST_DO;
output  ST_DO_EN;
input   ST_DO_BUSY;
input   [7:0]STS_I;
output  [7:0]STS_O;
input   [15:0]SOC_MAC1;
input   [15:0]SOC_MAC2;
input   [15:0]SOC_MAC3; 
input   [15:0]SOC_IP1;  
input   [15:0]SOC_IP2;
output  DMA_END;
input   [15:0]DMA_MAX;
output  DATA_OUT;
output  DATA_OUT_EN;
input   [7:0]DATA_IN;
input   DATA_IN_EN;
//output  TCP_SW;
//output  [3:0]HTTP_CNT1;
//output  [3:0]HTTP_CNT2;
//output  [3:0]SS_1;
//output  [3:0]SS_2;
//wire [3:0]SS_1;
//wire [3:0]SS_2;

reg FP_R_TMP;
reg FP_R;
reg [11:0]DAT_R_CNT;
reg [15:0]DES_MAC1 ; 
reg [15:0]DES_MAC2 ; 
reg [15:0]DES_MAC3 ;
wire [15:0]PK_SIZE;
reg [15:0]RCV_TYPE ; 
reg [15:0]DES_IP1  ;
reg [15:0]DES_IP2  ;
reg [7:0]PRT_NO ;
reg ARP_START ;
reg IP_START ;
reg [15:0]IP_ID ;
reg [15:0]ICMP_ID ;
reg [15:0]ICMP_SEQ ;
wire [15:0]IP_SIZE;
reg [15:0]IP_R_SIZE;
wire [7:0]IP_HD_SZ;
reg [7:0]IP_R_HD_SZ;
wire [3:0]IP_HD_B;
reg [7:0]TCP_R_HD_SZ;
reg [3:0]TCP_STATE;
reg [15:0]TCP_S_PORT ;
reg [15:0]TCP_R_PORT ;
reg [31:0]TCP_R_SEQ;
wire [31:0]TCP_S_SEQ;
reg [31:0]TCP_R_ACK_NO;
wire [31:0]TCP_S_ACK_NO;
reg TCP_R_ACK;
reg TCP_R_SYN;
reg TCP_R_PSH;
reg TCP_R_FIN;
reg TCP_R_RST;
reg TCP_S_ACK;
reg TCP_S_SYN;
reg TCP_S_PSH;
reg TCP_S_FIN;
reg TCP_S_RST;
reg [15:0]TCP_CSM;
wire [15:0] TCP_WIN_SIZE;
wire [16:0]TCP_CSM_A;
wire [16:0]TCP_CSM_B;
wire [16:0]TCP_CSM_B2;
wire [17:0]TCP_CSM_C;
wire SEND_END;
reg  SEND_END_D;
reg [7:0]ARP_CNT;
reg [15:0]ARP_DAT;
reg ARP_DAT_EN;
reg [7:0] IP_CNT ;
reg [15:0]IP_DAT ;
reg IP_DAT_EN;
reg [15:0]IP_CHKSUM;
reg [15:0]IP_CHKSUM_TMP;
reg [3:0]FIFO_WP;
reg [3:0]FIFO_RP;
reg FIFO_DO_EN;
reg FIFO_DO_EN_D;
reg FIFO_FULL;
wire [15:0] ICMP_CSM;
wire [16:0] ICMP_CSM_TMP;
wire [7:0] IP_CNT_MAX;
wire [15:0] R_DA_SIZE;
wire  [16:0]CHKSUM_A;
wire  [16:0]CHKSUM_B;
wire  [16:0]CHKSUM_C;
wire  [15:0]CHKSUM_D;
wire [15:0] IP_DAT_SEL;
wire  [16:0]CHKSUM_TMP_A;
wire  [16:0]CHKSUM_TMP_B; 
wire FIFO_DI_EN;
wire [15:0]FIFO_DI;
wire FIFO_DO_BUSY;
wire ST_DI_BUSY;
wire [7:0]STS_O;
wire ST_DO_EN;
reg [15:0]FIFO_MEM[0:15];
reg  DMA_END;
reg [3:0]HTTP_CNT1;
reg [3:0]HTTP_CNT2;
wire [7:0]DISP_1;
wire [7:0]DISP_2;
wire [15:0]HTTP_DAT;
wire [7:0]HTTP_ADR;
wire [15:0]TCP_DT_LG;
wire [7:0]HTTP_END;
//reg TCP_SW;
reg [3:0]ADR;
reg [16:0]DATE_CHK;
wire  [15:0]RTC_DAT;
reg DATA_OUT;
reg DATA_OUT_EN;
//*** RCV_block ****

assign ST_DI_BUSY = 1'b0;//FIFO_FULL;
assign STS_O = {7'b0000000,FIFO_DO_EN};
assign ST_DO_EN = FIFO_DO_EN;

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      FP_R_TMP <= 1'b0;
      FP_R <= 1'b0;
    end
  else
    if (ST_DI_EN==1'b1)
      begin
        FP_R_TMP <= STS_I[0];
        if ((FP_R_TMP==1'b0)&&(STS_I[0]==1'b1))
          FP_R <= 1'b1;
        else
          FP_R <= 1'b0;
      end
    else
      begin
        if (STS_I[0]==1'b0)
          FP_R_TMP <= 1'b0;
        else
          FP_R_TMP <= FP_R_TMP;
        FP_R <= 1'b0;
      end
end

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      DAT_R_CNT <= 12'h000;
    end
  else
    if (ST_DI_EN==1'b1)
      if  ((FP_R_TMP==1'b0)&&(STS_I[0]==1'b1))
        begin
          DAT_R_CNT <= 12'h000;
        end
      else
        if (DAT_R_CNT >= DMA_MAX[12:1])
          begin
            DAT_R_CNT <= 12'h000;
          end
        else
          begin                        
            DAT_R_CNT <= DAT_R_CNT +12'h01;
          end
    else
      begin
        DAT_R_CNT <= DAT_R_CNT;
      end
end

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      DMA_END <= 1'b0;
    end
  else
    if  (STS_I[0]==1'b1)
      if ((ST_DI_EN==1'b1)&& (DAT_R_CNT >= DMA_MAX[12:1]))
        begin
          DMA_END <= 1'b1;
        end
      else
        begin                        
          DMA_END <= DMA_END ;
        end
    else
      begin                        
        DMA_END <= 1'b0 ;
      end
end

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      DES_MAC1 <=16'h0000; 
      DES_MAC2 <=16'h0000; 
      DES_MAC3 <=16'h0000;
      RCV_TYPE <=16'h0000; 
      DES_IP1  <=16'h0000;
      DES_IP2  <=16'h0000;
      PRT_NO   <=8'hff;
      ARP_START <=1'b0;
      IP_ID <=16'h0000;
      ICMP_ID <=16'h0000;
      ICMP_SEQ <= 16'h0000;
      TCP_S_PORT <= 16'h0000;
      TCP_R_PORT <= 16'h0000;
      TCP_R_SEQ  <= 32'h00000000;
      TCP_R_ACK_NO <= 32'h00000000;
      TCP_R_ACK <= 1'b0;
      TCP_R_SYN <= 1'b0;
      TCP_R_PSH <= 1'b0;
      TCP_R_FIN <= 1'b0;
      TCP_R_RST <= 1'b0;
      IP_R_SIZE <= 16'h0000;
      IP_R_HD_SZ <= 8'h00;
      TCP_R_HD_SZ <= 8'h00;
      //TCP_SW <= 1'b0;
    end
  else
    if  (ST_DI_EN==1'b1)
      begin
        if (DAT_R_CNT==12'h002)
          DES_MAC1 <=ST_DI; 
        if (DAT_R_CNT==12'h003)
          DES_MAC2 <=ST_DI; 
        if (DAT_R_CNT==12'h004)
          DES_MAC3 <=ST_DI;  
        if (DAT_R_CNT==12'h005)
          RCV_TYPE <=ST_DI;
        if (RCV_TYPE==16'h0608) 
          begin
            if (DAT_R_CNT==12'h00d)
              DES_IP1<=ST_DI; 
            if (DAT_R_CNT==12'h00e)
              DES_IP2<=ST_DI;
          end                
        else
          if (RCV_TYPE==16'h0008) //IP
            begin
              if (DAT_R_CNT==12'h006)
                IP_R_HD_SZ <= {2'b00,ST_DI[3:0],2'b00};
              if (DAT_R_CNT==12'h007)
                IP_R_SIZE <= {ST_DI[7:0],ST_DI[15:8]};
              if (DAT_R_CNT==12'h00c)
                DES_IP1<=ST_DI; 
              if (DAT_R_CNT==12'h00d)
                DES_IP2<=ST_DI;  
            end
        if (RCV_TYPE==16'h0008)
          begin
            if (DAT_R_CNT==12'h008)
              IP_ID <= ST_DI;
            if (DAT_R_CNT==12'h00a)
              PRT_NO <= ST_DI[15:8];
          end
        if ((RCV_TYPE==16'h0008)&&(PRT_NO==8'h06)) //TCP
          begin
            if (DAT_R_CNT==12'h010)
              TCP_S_PORT <= ST_DI;
            if (DAT_R_CNT==12'h011)
              TCP_R_PORT <= ST_DI;
            if (DAT_R_CNT==12'h012)
              TCP_R_SEQ <= {ST_DI[7:0],ST_DI[15:8],TCP_R_SEQ[15:0]};
            else
              if (DAT_R_CNT==12'h013)
                TCP_R_SEQ <= {TCP_R_SEQ[31:16],ST_DI[7:0],ST_DI[15:8]};
              else
                TCP_R_SEQ <= TCP_R_SEQ;
            if (DAT_R_CNT==12'h014)
              TCP_R_ACK_NO <= {ST_DI[7:0],ST_DI[15:8],TCP_R_ACK_NO[15:0]};
            else
              if (DAT_R_CNT==12'h015)
                TCP_R_ACK_NO <= {TCP_R_ACK_NO[31:16],ST_DI[7:0],ST_DI[15:8]};
              else
                TCP_R_ACK_NO <= TCP_R_ACK_NO;
            if (DAT_R_CNT==12'h016)
              begin
                TCP_R_HD_SZ <= {2'b00,ST_DI[7:4],2'b00};
                TCP_R_FIN <= ST_DI[8];
                TCP_R_SYN <= ST_DI[9];
                TCP_R_RST <= ST_DI[10];
                TCP_R_PSH <= ST_DI[11];
                TCP_R_ACK <= ST_DI[12];
              end
            // *** HTTP DATA RCV sample ****
            /*
				if ((DAT_R_CNT==12'h01f)&&(TCP_STATE==4'd3))
              if (ST_DI==16'h313d) // "=1"
                TCP_SW <= 1'b1;
              else
                if (ST_DI==16'h303d)//"=0"
                  TCP_SW <= 1'b0;
                else
                  TCP_SW <= TCP_SW;
            else
              TCP_SW <= TCP_SW;
				*/
            // *** HTTP DATA RCV sample end ****
          end
        if ((RCV_TYPE==16'h0008)&&(PRT_NO==8'h01)) //ICMP
          begin
            if (DAT_R_CNT==12'h012)
              ICMP_ID  <= ST_DI;
            if (DAT_R_CNT==12'h013)
              ICMP_SEQ <= ST_DI;
          end
        if ((DAT_R_CNT==12'h00f)&&(RCV_TYPE==16'h0608)) // arp
          ARP_START <= 1'b1;
        else
          ARP_START <= 1'b0;
      end
    else
      begin
        ARP_START <= 1'b0;
      end
end



always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      IP_START  <=1'b0;
    end
  else
    if ((IP_START == 1'b0)&&(SEND_END_D==1'b1)&&((TCP_STATE==4'd4)||(TCP_STATE==4'd6)))
      IP_START <=1'b1;
    else
      if  (ST_DI_EN==1'b1)
        if ((DAT_R_CNT==12'h01f)&&(RCV_TYPE==16'h0008))
          if ((PRT_NO==8'h01)||((PRT_NO==8'h06)&&(TCP_STATE!=4'd0)&&(TCP_STATE!=4'd2)&&(TCP_STATE!=4'd4)&&(TCP_STATE!=4'd7))) // ip
            IP_START <=1'b1;
          else
            IP_START <= 1'b0;
        else
          IP_START <= 1'b0;
      else
        IP_START <= 1'b0;
end
	   

//*** ARP_block  ***
always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      ARP_CNT <= 8'hff;
      ARP_DAT <= 16'h0000;
      ARP_DAT_EN <= 1'b0;
    end
  else
    begin
      if (ARP_START==1'b1)
        ARP_CNT <= 8'h00;
      else
        if (FIFO_FULL==1'b0)
          if (ARP_CNT>8'h3c)
            ARP_CNT <= ARP_CNT;
          else
            ARP_CNT <= ARP_CNT +8'h01;
        else
          ARP_CNT <= ARP_CNT;
      if (FIFO_FULL==1'b0)
        begin
          if ((8'h00<=ARP_CNT)&&(ARP_CNT<=8'h3c))
            ARP_DAT_EN <=1'b1;
          else
            ARP_DAT_EN <=1'b0;
          case(ARP_CNT)  
            8'h00:ARP_DAT <= 16'h0000;
            8'h01:ARP_DAT <= 16'h0040;
            8'h02:ARP_DAT <= 16'h003C;
            8'h03:ARP_DAT <= 16'h0000;
            8'h04:ARP_DAT <= DES_MAC1;
            8'h05:ARP_DAT <= DES_MAC2;
            8'h06:ARP_DAT <= DES_MAC3;
            8'h07:ARP_DAT <= SOC_MAC1;
            8'h08:ARP_DAT <= SOC_MAC2;
            8'h09:ARP_DAT <= SOC_MAC3;
            8'h0a:ARP_DAT <= 16'h0608;
            8'h0b:ARP_DAT <= 16'h0100;
            8'h0c:ARP_DAT <= 16'h0008;
            8'h0d:ARP_DAT <= 16'h0406;
            8'h0e:ARP_DAT <= 16'h0200; 
            8'h0f:ARP_DAT <= SOC_MAC1;
            8'h10:ARP_DAT <= SOC_MAC2;
            8'h11:ARP_DAT <= SOC_MAC3;  
            8'h12:ARP_DAT <= SOC_IP1;
            8'h13:ARP_DAT <= SOC_IP2;
            8'h14:ARP_DAT <= DES_MAC1;
            8'h15:ARP_DAT <= DES_MAC2;
            8'h16:ARP_DAT <= DES_MAC3;
            8'h17:ARP_DAT <= DES_IP1;
            8'h18:ARP_DAT <= DES_IP2;
            default:ARP_DAT <= 16'h00;
          endcase
        end
      else
        begin
          ARP_DAT_EN <= ARP_DAT_EN ;
          ARP_DAT <= ARP_DAT;
        end
    end
end

//*** IP_block ***

assign TCP_DT_LG = 16'h018C; //(http_adr_max+1) x2
assign HTTP_END = 8'hE5; //http_adr_max + 8'h1f
assign IP_CNT_MAX = (PRT_NO==8'h01)?8'h20:(PRT_NO==8'h06)?((TCP_STATE==4'd1)?8'h20:(TCP_STATE==4'd4)?HTTP_END:8'h1e):8'h00;
assign IP_SIZE =(PRT_NO==8'h01)?16'h002C:(PRT_NO==8'h06)?((TCP_STATE==4'd1)?8'h2c:(TCP_STATE==4'd4)?(TCP_DT_LG+16'h0028):16'h0028):16'h002c;
assign PK_SIZE   =(PRT_NO==8'h01)?16'h003C:((PRT_NO==8'h06)&&(IP_SIZE>16'h2f))?IP_SIZE+16'h0e:16'h003c;
assign IP_HD_SZ=(PRT_NO==8'h06)?((TCP_STATE==4'd1)?8'h20:8'h1e):8'h1e;
assign IP_HD_B=(PRT_NO==8'h06)?((TCP_STATE==4'd1)?4'h6:4'h5):4'h5;

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      IP_CNT <= 8'hff;
      IP_DAT <= 16'h00;
      IP_DAT_EN <= 1'b0;
    end
  else
    begin
      if ((IP_START==1'b1)&&((PRT_NO==8'h01)||(PRT_NO==8'h06)))
        IP_CNT <= 8'h00;
      else
        if (FIFO_FULL==1'b0)
          if (IP_CNT>IP_CNT_MAX)
            IP_CNT <= 8'hff;
          else
            IP_CNT <= IP_CNT +8'h01;
        else
          IP_CNT <= IP_CNT;
      if (FIFO_FULL==1'b0)
        begin
          if ((8'h00<=IP_CNT)&&(IP_CNT<=IP_CNT_MAX))
            IP_DAT_EN <=1'b1;
          else
            IP_DAT_EN <=1'b0;
          if  ((8'h00<=IP_CNT)&&(IP_CNT<=8'h14)) // IP_HAEDER
            case(IP_CNT)  
              8'h00:IP_DAT <= 16'h0000;
              8'h01:IP_DAT <= 16'h0040;
              8'h02:IP_DAT <= PK_SIZE;
              8'h03:IP_DAT <= {8'h00,PK_SIZE[15:8]};
              8'h04:IP_DAT <= DES_MAC1;
              8'h05:IP_DAT <= DES_MAC2;
              8'h06:IP_DAT <= DES_MAC3;
              8'h07:IP_DAT <= SOC_MAC1;
              8'h08:IP_DAT <= SOC_MAC2;
              8'h09:IP_DAT <= SOC_MAC3;
              8'h0a:IP_DAT <= 16'h0008;
              8'h0b:IP_DAT <= 16'h0045;
              8'h0c:IP_DAT <= {IP_SIZE[7:0],IP_SIZE[15:8]};
              8'h0d:IP_DAT <= IP_ID;
              8'h0e:IP_DAT <= 16'h0000;
              8'h0f:IP_DAT <= {PRT_NO,8'h20};
              8'h10:IP_DAT <= ~ {IP_CHKSUM[7:0],IP_CHKSUM[15:8]};
              8'h11:IP_DAT <= SOC_IP1;
              8'h12:IP_DAT <= SOC_IP2;
              8'h13:IP_DAT <= DES_IP1;
              8'h14:IP_DAT <= DES_IP2;
              default:IP_DAT <= 16'h00;
            endcase
          else
            if (PRT_NO==8'h01) //ICMP
              case(IP_CNT)
                8'h15:IP_DAT <= 16'h0000; //ICMP
                8'h16:IP_DAT <= ~ ICMP_CSM[15:0]; //ICMP
                8'h17:IP_DAT <= ICMP_ID;  //ICMP
                8'h18:IP_DAT <= ICMP_SEQ; //ICMP
                default:IP_DAT <= 16'h00;
              endcase
            else
              if (PRT_NO==8'h06) //TCP
                if  ((8'h15<=IP_CNT)&&(IP_CNT<=IP_HD_SZ))
                  case(IP_CNT)
                    8'h15:IP_DAT <= TCP_R_PORT; // my_port 
                    8'h16:IP_DAT <= TCP_S_PORT; // to_port
                    8'h17:IP_DAT <= {TCP_S_SEQ[23:16],TCP_S_SEQ[31:24]}; //SEQ_NO
                    8'h18:IP_DAT <= {TCP_S_SEQ[7:0],TCP_S_SEQ[15:8]};  //SEQ_NO
                    8'h19:IP_DAT <= {TCP_S_ACK_NO[23:16],TCP_S_ACK_NO[31:24]}; //ACK_NO
                    8'h1a:IP_DAT <= {TCP_S_ACK_NO[7:0],TCP_S_ACK_NO[15:8]};  //ACK_NO
                    8'h1b:IP_DAT <= {2'b00,1'b0,TCP_S_ACK,TCP_S_PSH,TCP_S_RST,TCP_S_SYN,TCP_S_FIN,IP_HD_B,4'h0};  //SEQ_NO
                    8'h1c:IP_DAT <= {TCP_WIN_SIZE[7:0],TCP_WIN_SIZE[15:8]};
                    8'h1d:IP_DAT <= ~{TCP_CSM[7:0],TCP_CSM[15:8]};
                    8'h1e:IP_DAT <= 16'h0000;
                    8'h1f:IP_DAT <= 16'h0402; // OP1 SYNC
                    8'h20:IP_DAT <= 16'hB405; //1 OP SYNC
                    default:IP_DAT <= 16'h0000;
                  endcase
                else
                  if (TCP_STATE==4'd4)//** ESTAB1 **	
                    if (HTTP_ADR==8'h6b)
                      IP_DAT <= {DISP_1,DISP_2};
                    else
                      if (((HTTP_ADR>=8'hb)&&(HTTP_ADR<=8'h17))||((HTTP_ADR>=8'h29)&&(HTTP_ADR<=8'h35)))
                        IP_DAT <= RTC_DAT;
                      else
                        IP_DAT <= HTTP_DAT;
                  else
                    IP_DAT <= 16'h0000;
              else
                IP_DAT <= 16'h0000;
        end
      else
        begin
          IP_DAT_EN <= IP_DAT_EN ;
          IP_DAT <= IP_DAT;
        end
    end
end

assign R_DA_SIZE = IP_R_SIZE - IP_R_HD_SZ - TCP_R_HD_SZ;
assign TCP_S_SEQ = (TCP_R_ACK_NO==32'h0)?32'h00010001:(TCP_STATE==4'd6)?TCP_R_ACK_NO + TCP_DT_LG:TCP_R_ACK_NO;
assign TCP_S_ACK_NO = (R_DA_SIZE==16'h00)?TCP_R_SEQ+32'd1:TCP_R_SEQ+R_DA_SIZE ;

assign CHKSUM_A =IP_CHKSUM + {IP_DAT[7:0],IP_DAT[15:8]} ;
assign CHKSUM_B =CHKSUM_A[15:0] + CHKSUM_A[16];
assign CHKSUM_C =CHKSUM_B[15:0]+IP_CHKSUM_TMP[15:0];
assign CHKSUM_D =CHKSUM_C[15:0] + CHKSUM_C[16];

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      IP_CHKSUM <= 16'h0000;
    end
  else
    begin
      if ((IP_DAT_EN==1'b1)&(FIFO_FULL==1'b0))
        if (IP_CNT<=8'h01)
          IP_CHKSUM <= 16'h0000;
        else
          if ((8'h0c <=IP_CNT)&&(IP_CNT<=8'h0e))
            IP_CHKSUM <= CHKSUM_B[15:0];
          else
            if (IP_CNT==8'h0f)
              IP_CHKSUM <= CHKSUM_D[15:0];
            else
              IP_CHKSUM <= IP_CHKSUM;
      else
        IP_CHKSUM <= IP_CHKSUM;
    end
end

assign IP_DAT_SEL =(IP_CNT==8'h02)?{8'h20,PRT_NO}:
                   (IP_CNT==8'h03)?{SOC_IP1[7:0],SOC_IP1[15:8]}:
                   (IP_CNT==8'h04)?{SOC_IP2[7:0],SOC_IP2[15:8]}:
                   (IP_CNT==8'h05)?{DES_IP1[7:0],DES_IP1[15:8]}:
                   (IP_CNT==8'h06)?{DES_IP2[7:0],DES_IP2[15:8]}:
                                   16'h0000;

assign CHKSUM_TMP_A =IP_CHKSUM_TMP + IP_DAT_SEL;
assign CHKSUM_TMP_B =CHKSUM_TMP_A[15:0] + CHKSUM_TMP_A[16];

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      IP_CHKSUM_TMP <= 16'h0000;
    end
  else
    begin
      if ((IP_DAT_EN==1'b1)&(FIFO_FULL==1'b0))
        if (IP_CNT<=8'h01)
          IP_CHKSUM_TMP <= 16'h0000;
        else
          if ((8'h02 <=IP_CNT)&&(IP_CNT<=8'h06))
            IP_CHKSUM_TMP <= CHKSUM_TMP_B[15:0];
          else
            IP_CHKSUM_TMP <= IP_CHKSUM_TMP;
      else
        IP_CHKSUM_TMP <= IP_CHKSUM_TMP;
    end
end

assign ICMP_CSM_TMP = ICMP_ID + ICMP_SEQ;
assign ICMP_CSM  = (ICMP_CSM_TMP[15:0] + ICMP_CSM_TMP[16]);
//TCP_CHKSUM
assign TCP_WIN_SIZE=16'h0500;
assign TCP_CSM_A =TCP_CSM + {IP_DAT[7:0],IP_DAT[15:8]} ;
assign TCP_CSM_B =TCP_CSM_A[15:0] + TCP_CSM_A[16] ;
assign TCP_CSM_B2 = TCP_CSM_B + TCP_WIN_SIZE;
assign TCP_CSM_C =(TCP_STATE==4'd4)? TCP_CSM_B2 +16'h583b+DATE_CHK+DATE_CHK+{DISP_2,DISP_1}:TCP_CSM_B2 ; // 583b:http_rom

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      TCP_CSM <= 16'h0000;
    end
  else
    begin
      if ((IP_DAT_EN==1'b1)&(FIFO_FULL==1'b0))
        if (IP_CNT<=8'h01)
          if (TCP_STATE==4'd1)
            TCP_CSM <= 16'h0006+16'h0018+16'h0204+16'h05b4;
          else
            if (TCP_STATE==4'd4)
              TCP_CSM <= 16'h0006+16'h0014+TCP_DT_LG;
            else
              TCP_CSM <= 16'h0006+16'h0014;
        else
          if ((8'h12 <=IP_CNT)&&(IP_CNT<=8'h1b))
            TCP_CSM <= TCP_CSM_B[15:0];
          else
            if (IP_CNT==8'h1c)
              TCP_CSM <= TCP_CSM_C[15:0]+TCP_CSM_C[17:16];
            else
              TCP_CSM <= TCP_CSM;
      else
        TCP_CSM <= TCP_CSM;
    end
end

assign SEND_END = ((FIFO_DO_EN==1'b0)&&(FIFO_DO_EN_D==1'b1))?1'b1:1'b0;

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      FIFO_DO_EN_D <= 1'b1;
      SEND_END_D <= 1'b0;
    end
  else
    begin
      FIFO_DO_EN_D <= FIFO_DO_EN ;
      SEND_END_D <= SEND_END;
    end
end

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      TCP_STATE <= 4'd0; //** LISTEN **
    end
  else
    if ((DAT_R_CNT==12'h017)&&(PRT_NO==8'h06)&&(ST_DI_EN==1'b1)&&(RCV_TYPE==16'h0008))
      begin
        if  (TCP_R_RST==1'b1)
          TCP_STATE <= 4'd0;
        else
          if (TCP_R_PORT!=16'h5000)
            TCP_STATE <= 4'd9;
          else
            case(TCP_STATE)  
              4'd0:
                if (TCP_R_SYN==1'b1) //** LISTEN **
	  	    TCP_STATE <= 4'd1; // to SYN_RCVD
                else
                  TCP_STATE <= 4'd0; // hold
              4'd1:
                if (TCP_R_ACK==1'b1) //** SYN_RCVD **
                  TCP_STATE <= 4'd2; // to ESTAB0
                else
                  TCP_STATE <= 4'd1; // hold
              4'd2:
                if (TCP_R_PSH==1'b1) //** ESTAB0 **
                  TCP_STATE <= 4'd3; // to ESTAB1
                else
                  TCP_STATE <= 4'd2; // hold
              4'd3:
                TCP_STATE <= 4'd4;  //** ESTAB1 **
              4'd4:
                if (TCP_R_FIN==1'b1) //** ESTAB2 **
                  TCP_STATE <= 4'd5; // to CLOSE_WAITE
                else
                  TCP_STATE <= 4'd6; // hold
              4'd5:
                if (TCP_R_ACK==1'b1) //** CLOSE_WAITE **
                  TCP_STATE <= 4'd0; // to LISTEN
                else
                  TCP_STATE <= 4'd5; // hold
              4'd6:
                TCP_STATE <= 4'd7; //** FINE **
              4'd7:
                if (TCP_R_FIN==1'b1) //** WAITE FINE **
		    TCP_STATE <= 4'd8; // to CLOSE
                else
                  TCP_STATE <= 4'd7; // hold
              4'd8:TCP_STATE <= 4'd0; //** CLOSE
              default:TCP_STATE <= 4'd0;
            endcase
      end
    else
      begin
        if (SEND_END==1'b1)
          if (TCP_STATE == 4'd3)
            TCP_STATE <= 4'd4;
          else
            if (TCP_STATE == 4'd4)
              TCP_STATE <= 4'd6;   
            else
              if (TCP_STATE == 4'd6)
                TCP_STATE <= 4'd7;   
              else
                if ((TCP_STATE == 4'd8)||(TCP_STATE == 4'd9))
                  TCP_STATE <= 4'd0;   
                else
                  TCP_STATE <= TCP_STATE; //hold
        else
          TCP_STATE <= TCP_STATE; //hold
      end
end

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      TCP_S_ACK<=1'b0;
      TCP_S_SYN<=1'b0;
      TCP_S_PSH<=1'b0;
      TCP_S_FIN<=1'b0;
      TCP_S_RST<=1'b0;
    end
  else
    begin
      case(TCP_STATE)
        4'd0:begin //** LISTEN **
               TCP_S_ACK<=1'b0;
               TCP_S_SYN<=1'b0;
               TCP_S_PSH<=1'b0;
               TCP_S_FIN<=1'b0;
               TCP_S_RST<=1'b0;
             end  
        4'd1:begin //** SYN_RCVD **
               TCP_S_ACK<=1'b1;
               TCP_S_SYN<=1'b1;
               TCP_S_PSH<=1'b0;
               TCP_S_FIN<=1'b0;
               TCP_S_RST<=1'b0;
             end
        4'd2:begin //** ESTAB0 **
               TCP_S_ACK<=1'b0;
               TCP_S_SYN<=1'b0;
               TCP_S_PSH<=1'b0;
               TCP_S_FIN<=1'b0;
               TCP_S_RST<=1'b0;
             end
        4'd3:begin //** ESTAB1 **
               TCP_S_ACK<=1'b1;
               TCP_S_SYN<=1'b0;
               TCP_S_PSH<=1'b0;
               TCP_S_FIN<=1'b0;
               TCP_S_RST<=1'b0;
             end
        4'd4:begin //** ESTAB2 **
               TCP_S_ACK<=1'b1;
               TCP_S_SYN<=1'b0;
               TCP_S_PSH<=1'b1;
               TCP_S_FIN<=1'b0;
               TCP_S_RST<=1'b0;
             end
        4'd5:begin //** CLOSE_WAITE **
               TCP_S_ACK<=1'b1;
               TCP_S_SYN<=1'b0;
               TCP_S_PSH<=1'b0;
               TCP_S_FIN<=1'b1;
               TCP_S_RST<=1'b0;
             end
        4'd6:begin //** FINE **
               TCP_S_ACK<=1'b1;
               TCP_S_SYN<=1'b0;
               TCP_S_PSH<=1'b0;
               TCP_S_FIN<=1'b1;
               TCP_S_RST<=1'b0;
	      end
        4'd7:begin //** WAITE FINE **
               TCP_S_ACK<=1'b0;
               TCP_S_SYN<=1'b0;
               TCP_S_PSH<=1'b0;
               TCP_S_FIN<=1'b0;
               TCP_S_RST<=1'b0;
             end
        4'd8:begin //** CLOSE **
               TCP_S_ACK<=1'b1;
               TCP_S_SYN<=1'b0;
               TCP_S_PSH<=1'b0;
               TCP_S_FIN<=1'b0;
               TCP_S_RST<=1'b0;
             end
        4'd9:begin //** RST **
               TCP_S_ACK<=1'b0;
               TCP_S_SYN<=1'b0;
               TCP_S_PSH<=1'b0;
               TCP_S_FIN<=1'b0;
               TCP_S_RST<=1'b1;
	      end
        default:
             begin
               TCP_S_ACK<=1'b0;
               TCP_S_SYN<=1'b0;
               TCP_S_PSH<=1'b0;
               TCP_S_FIN<=1'b0;
               TCP_S_RST<=1'b0;
             end
      endcase
    end	  
end

//*** HTTP_block ***


always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      HTTP_CNT1<= 4'h0;
      HTTP_CNT2<= 4'h0;
    end
  else
    if (DATA_IN_EN==1'b1)
      begin
        HTTP_CNT1<= DATA_IN[3:0];
        HTTP_CNT2<= DATA_IN[7:4];
      end
    else
      begin
	 HTTP_CNT1 <= HTTP_CNT1 ;
	 HTTP_CNT2 <= HTTP_CNT2 ;
      end
end


//assign DISP_1 = 8'h30 + DATA_IN[3:0];
//assign DISP_2 = 8'h30 + DATA_IN[7:4];
assign DISP_1 = 8'h30 + HTTP_CNT1 ;
assign DISP_2 = 8'h30 + HTTP_CNT2 ;


always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      DATA_OUT <= 1'b0;
      DATA_OUT_EN <= 1'b0;
    end
  else
    if  (ST_DI_EN==1'b1)
      begin
        if ((RCV_TYPE==16'h0008)&&(PRT_NO==8'h06)) //TCP
          begin
            // *** HTTP DATA RCV sample ****
            if ((DAT_R_CNT==12'h01f)&&(TCP_STATE==4'd3))
              if (ST_DI==16'h313d) // "=1"
                begin
                  DATA_OUT <= 1'b1;
                  DATA_OUT_EN <= 1'b1;
                end
              else
                if (ST_DI==16'h303d)//"=0"
                  begin
                    DATA_OUT <= 1'b0;
                    DATA_OUT_EN <= 1'b1;
                  end
                else
                  begin
                    DATA_OUT <= DATA_OUT;
                    DATA_OUT_EN <= 1'b0;
                  end

            else
              begin
                DATA_OUT <= DATA_OUT;
                DATA_OUT_EN <= 1'b0;
              end
            // *** HTTP DATA RCV sample end ****
          end
      end
    else
      begin
        DATA_OUT <= DATA_OUT;
        DATA_OUT_EN <= 1'b0;
      end
end


//*** FIFO_block ***

assign FIFO_DI_EN = (RCV_TYPE==16'h0608)?ARP_DAT_EN:IP_DAT_EN;
assign FIFO_DI = (RCV_TYPE==16'h0608)?ARP_DAT:IP_DAT;
assign FIFO_DO_BUSY = ST_DO_BUSY; 

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      FIFO_WP <= 4'h0;
      FIFO_RP <= 4'h0;
      FIFO_DO_EN <=1'b0;
      FIFO_FULL <=1'b0;
    end
  else
    begin
      if ((FIFO_DI_EN==1'b1)&&(FIFO_FULL==1'b0))
        FIFO_WP <= FIFO_WP + 4'h1;
      else
        FIFO_WP <= FIFO_WP;
      if ((FIFO_DO_BUSY==1'b0)&&(FIFO_DO_EN==1'b1))
        FIFO_RP <= FIFO_RP + 4'h1;
      else
        FIFO_RP <= FIFO_RP;
      if ((FIFO_DI_EN==1'b1)&&(FIFO_DO_BUSY==1'b1)&&(FIFO_RP==FIFO_WP+4'h1))
        FIFO_FULL <= 1'b1;
      else
        if ((FIFO_FULL==1'b1)&&(FIFO_DO_BUSY==1'b0)&&(FIFO_RP==FIFO_WP))
          FIFO_FULL <=1'b0;
        else
         FIFO_FULL <= FIFO_FULL;
      if ((FIFO_DI_EN==1'b0)&&(FIFO_DO_BUSY==1'b0)&&(FIFO_WP==FIFO_RP+4'h1))
        FIFO_DO_EN <= 1'b0;
      else
        if ((FIFO_DI_EN==1'b1)&&(FIFO_DO_BUSY==1'b1)&&(FIFO_RP==FIFO_WP))
          FIFO_DO_EN <=1'b1;
        else
          FIFO_DO_EN <= FIFO_DO_EN;
    end
end

always@(posedge CLK)
begin
if ((FIFO_DI_EN==1'b1)&&(FIFO_FULL==1'b0))
  FIFO_MEM[FIFO_WP]<= FIFO_DI;
end

assign ST_DO  = FIFO_MEM[FIFO_RP];

assign HTTP_ADR = IP_CNT-8'h1f;

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      ADR <= 4'h0;
      DATE_CHK <= 17'h00000;
    end
  else
    if (IP_CNT==8'h0)
      begin
        ADR <= 4'h0;
        DATE_CHK <= 17'h00000;
      end
    else
      if ((IP_DAT_EN==1'b1)&(FIFO_FULL==1'b0))
        begin
          if (IP_CNT<= 8'hD)
            ADR<=IP_CNT[3:0];
          else
            if (HTTP_ADR <= 8'h17)
              ADR<=HTTP_ADR[3:0]+4'h6;
            else
              if (HTTP_ADR <= 8'h35)
                ADR<=HTTP_ADR[3:0]+8'h8;
              else
                ADR<=IP_CNT[3:0];
          if (IP_CNT< 8'hE)
            DATE_CHK <= DATE_CHK[15:0]+DATE_CHK[16]+{RTC_DAT[7:0],RTC_DAT[15:8]};
          else
            DATE_CHK <= DATE_CHK;
        end
      else
        begin
          ADR <= ADR;
          DATE_CHK <= DATE_CHK;
        end
end

http_rom http_rom_1 (
	.A(HTTP_ADR),
      .IP_DAT(HTTP_DAT));

DATE_CNT DATE_CNT1T(
     .CLK(CLK)
    ,.RST(RST)
    ,.ADR(ADR)
    ,.DAT(RTC_DAT)
    //,.SS_1(SS_1)
    //,.SS_2(SS_2)
     ); 
endmodule















