//module:MINI_CPU 
//Ver 0.50
//date 20/01/2003
//Kenji Yokomizo <kyokomi@mvi.biglobe.ne.jp>

module  MINI_CPU (CLK,RST,U_START,U_END,U_CMD,U_ADR,U_DI,U_DO,U_BUSY,
                  ST_DO,ST_DO_EN,ST_DO_BUSY,ST_DI,ST_DI_EN,ST_DI_BUSY,STS_I,STS_O,
                  REG_M1,REG_M2,REG_M3,REG_M4,REG_M5,DMA_END,DMA_MAX,TCP_SW,HTTP_CNT1,HTTP_CNT2,
                  PRC_LED,LED_SEL,CLK_LED
                  );

input   CLK,RST;
// User IF
output U_START; // 1:start
input  U_END;   // 1:end
output [1:0] U_CMD; // [MEM(XIO),read(xwrite)] 00:IOW 01:IOR 10:MEMW 11:MEMR   
output [19:0] U_ADR;
output [15:0] U_DO;
input  [15:0] U_DI;
input  U_BUSY;

output [15:0]ST_DO;
output ST_DO_EN;
input  ST_DO_BUSY;
input  [15:0]ST_DI;
input  ST_DI_EN;
output ST_DI_BUSY;
input  [7:0]STS_I;
output [7:0]STS_O;

output [7:0]PRC_LED;
output [4:0]LED_SEL;
input  CLK_LED;
/*
output [7:0]SEND_DT;
output SEND;
input  [7:0]RCV_DT;
input  RCV;
input  S_BUSY;
*/ 
output [15:0] REG_M1; 
output [15:0] REG_M2; 
output [15:0] REG_M3; 
output [15:0] REG_M4;
output [15:0] REG_M5;
input DMA_END;
output [15:0]DMA_MAX;
input TCP_SW;
input [3:0]HTTP_CNT1;
input [3:0]HTTP_CNT2;

reg [7:0] PG_CNT;
wire SEL_VAL;
wire CMD_EN;
reg [7:0]REG_A;
reg [7:0]REG_B;
reg [7:0]STS_O;
reg ST_DO_EN ;
reg [15:0]ST_DO;
//reg ST_DI_BUSY;
wire ST_DI_BUSY;
wire [7:0]R8_0;
wire [7:0]R8_1; 
wire [7:0]R8_2; 
wire [7:0]R8_3;
wire [7:0]R8_4;
wire [7:0]R8_5;
wire [7:0]R8_6;
wire [7:0]R8_7;
wire [7:0]R8_8;
wire [7:0]R8_9; 
wire [7:0]R8_a; 
wire [7:0]R8_b;
wire [7:0]R8_c;
wire [7:0]R8_d;
wire [7:0]R8_e;
wire [7:0]R8_f;

wire R8_0_HIT;
wire R8_1_HIT; 
wire R8_2_HIT; 
wire R8_3_HIT;
wire R8_4_HIT;
wire R8_5_HIT;
wire R8_6_HIT;
wire R8_7_HIT;
wire R8_8_HIT;
wire R8_9_HIT; 
wire R8_a_HIT; 
wire R8_b_HIT;
wire R8_c_HIT;
wire R8_d_HIT;
wire R8_e_HIT;
wire R8_f_HIT;
//wire R8_10_HIT;
//wire R8_11_HIT; 
//wire R8_12_HIT; 
//wire R8_13_HIT;
//wire R8_14_HIT;
//wire R8_15_HIT;
//wire R8_16_HIT;
//wire R8_17_HIT;
//wire R8_18_HIT;
//wire R8_19_HIT; 
//wire R8_1a_HIT; 
//wire R8_1b_HIT;
//wire R8_1c_HIT;
//wire R8_1d_HIT;
//wire R8_1e_HIT;
//wire R8_1f_HIT;

reg [19:0]MEM[0:78];
reg [1:0] U_CMD;
reg [19:0] U_ADR;
reg [15:0] U_DAT;
reg U_START;
reg [12:0] ISA_DAT; 
reg WAIT_SIG;

wire [12:0] ISA_BASE;
wire [15:0] PG_CNT_NEXT;

wire [7:0]A;
wire [15:0]SPO;

reg [15:0] LED_CNT;
reg [4:0] LED_SEL;
wire [7:0]LED;
wire [7:0]SEG0,SEG1,SEG2,SEG3;

wire [15:0]SEG_TMP;

reg [15:0]DMA_MAX;
/*
reg SEND;  
reg [7:0] SEND_DT;
reg [7:0] SEND_DT_1;
reg [7:0] SEND_DT_2;
reg [7:0] SEND_DT_3;
reg [7:0] SEND_DT_4;
reg [4:0]SEND_CASE;
*/
//DMY
/*
wire SEND;
wire [7:0] SEND_DT;
wire [7:0] SEND_DT_1;
wire [7:0] SEND_DT_2;
wire [7:0] SEND_DT_3;
wire [7:0] SEND_DT_4;
wire [4:0]SEND_CASE;
//DMY END
*/
wire [7:0]SEL_DAT;
wire [15:0]SEL_DAT16;
wire [7:0]COMP;

wire [15:0]REG_M1;
wire [15:0]REG_M2;
wire [15:0]REG_M3;

reg [7:0] MAX_PG;

assign REG_M1={R8_1,R8_0};
assign REG_M2={R8_3,R8_2}; 
assign REG_M3={R8_5,R8_4}; 
assign REG_M4={R8_7,R8_6};
assign REG_M5={R8_9,R8_8};

reg [7:0]ANS_MON;

wire [7:0]SEL_DAT_H;
wire [7:0]SEL_DAT_L;

// program counter

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      PG_CNT <= 8'h00;
    end
  else
    if (CMD_EN==1'b1)
       if (SPO[14:8]==7'h41) 
         PG_CNT <= SEL_DAT;   
       else
         if (SPO[15:12]==4'hf)
           if (((SPO[10:8]==3'b101)&&(REG_A==SEL_DAT))||((SPO[10:8]==3'b110)&&(REG_A>SEL_DAT))||((SPO[10:8]==3'b111)&&(REG_A<SEL_DAT)))
             PG_CNT <= REG_B;
           else
             PG_CNT <= PG_CNT_NEXT;
         else
           if (SPO[15:8]==8'h47)
             if (DMA_END==1'b0)
               PG_CNT <= PG_CNT;
             else
               PG_CNT <= PG_CNT_NEXT;
           else
             PG_CNT <= PG_CNT_NEXT;
    else
      PG_CNT <= PG_CNT ;
end

assign A  = PG_CNT[7:0];
assign PG_CNT_NEXT =  PG_CNT +8'h01;

//command dec

assign CMD_EN = ( ( ((SPO[14]==1'b0)||((SEL_VAL==1'b0)&(SPO[6]==1'b0)))&&(U_END==1'b0) ) ||
                  ((SPO[15:8]==8'h47)&&(ST_DO_BUSY==1'b1))||
                  ((SPO[15:8]==8'h46)&&(ST_DI_EN==1'b0))
                )?1'b0:1'b1;

assign SEL_VAL = ((SPO[15]==1'b1)&&(SPO[14:11]!=4'b1111)) ? 1'b1:1'b0;

assign SEL_DAT = (SEL_VAL==1'b1)? SPO[7:0]:
                 (SPO[7:6]==2'b00)? U_DI[7:0]:
                 (SPO[7:0]==8'h41)? PG_CNT:
                 (SPO[7:0]==8'h42)? REG_A:
                 (SPO[7:0]==8'h43)? REG_B:
                 (SPO[7:0]==8'h44)? STS_I:
                 (SPO[7:0]==8'h45)? STS_O:
                 (SPO[7:0]==8'h48)? 8'h00:
                 (SPO[7:0]==8'h49)? 8'h01:
                 (SPO[7:0]==8'h4a)? 8'h02:
                 (SPO[7:0]==8'h4b)? 8'hfe:
                 (SPO[7:0]==8'h4c)? 8'hff:
                 (SPO[7:0]==8'h50)? R8_0:
                 (SPO[7:0]==8'h51)? R8_1:
                 (SPO[7:0]==8'h52)? R8_2:
                 (SPO[7:0]==8'h53)? R8_3:
                 (SPO[7:0]==8'h54)? R8_4:
                 (SPO[7:0]==8'h55)? R8_5:
                 (SPO[7:0]==8'h56)? R8_6:
                 (SPO[7:0]==8'h57)? R8_7:
                 (SPO[7:0]==8'h58)? R8_8:
                 (SPO[7:0]==8'h59)? R8_9:
                 (SPO[7:0]==8'h5a)? R8_a:
                 (SPO[7:0]==8'h5b)? R8_b:
                 (SPO[7:0]==8'h5c)? R8_c:
                 (SPO[7:0]==8'h5d)? R8_d:
                 (SPO[7:0]==8'h5e)? R8_e:
                 (SPO[7:0]==8'h5f)? R8_f:
                 //(SPO[7:0]==8'h60)? R8_10:
                 //(SPO[7:0]==8'h61)? R8_11:
                 //(SPO[7:0]==8'h62)? R8_12:
                 //(SPO[7:0]==8'h63)? R8_13:
                 //(SPO[7:0]==8'h64)? R8_14:
                 //(SPO[7:0]==8'h65)? R8_15:
                 //(SPO[7:0]==8'h66)? R8_16:
                 //(SPO[7:0]==8'h67)? R8_17:
                 //(SPO[7:0]==8'h68)? R8_18:
                 //(SPO[7:0]==8'h69)? R8_19:
                 //(SPO[7:0]==8'h6a)? R8_1a:
                 //(SPO[7:0]==8'h6b)? R8_1b:
                 //(SPO[7:0]==8'h6c)? R8_1c:
                 //(SPO[7:0]==8'h6d)? R8_1d:
                 //(SPO[7:0]==8'h6e)? R8_1e:
                 //(SPO[7:0]==8'h6f)? R8_1f:
					  8'h00;

assign SEL_DAT16=(SPO[15]==1'b1)?{SEL_DAT,SEL_DAT}:
                 (SPO[7:6]==2'b00)? (((SPO[8]==1'b0)||(SPO[15:8]==7'h47)||(SPO[15:12]==4'h7))?U_DI[15:0]:{U_DI[7:0],U_DI[7:0]}):
                 (SPO[7:0]==8'h46)? {ST_DI}:
                 (SPO[7:0]==8'h70)? {R8_1,R8_0}:
                 (SPO[7:0]==8'h71)? {R8_3,R8_2}:
                 (SPO[7:0]==8'h72)? {R8_5,R8_4}:
                 (SPO[7:0]==8'h73)? {R8_7,R8_6}:
                 (SPO[7:0]==8'h74)? {R8_9,R8_8}:
                 (SPO[7:0]==8'h75)? {R8_b,R8_a}:
                 (SPO[7:0]==8'h76)? {R8_d,R8_c}:
                 (SPO[7:0]==8'h77)? {R8_f,R8_e}:
					  {SEL_DAT,SEL_DAT};


always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      REG_A <= 16'h0000;
    end
  else
    if (SPO[14:8]==7'h42)
      REG_A <= SEL_DAT;
    else
      if (SPO[15:12]==4'hf)
        case (SPO[10:8])
          3'b000: REG_A  <= REG_A + SEL_DAT;
          3'b001: REG_A  <= REG_A - SEL_DAT;
          3'b010: REG_A  <= REG_A & SEL_DAT;
          3'b011: REG_A  <= REG_A | SEL_DAT;
          3'b100: REG_A  <= REG_A ^ SEL_DAT;
			 default: REG_A <= REG_A;
        endcase
      else
        REG_A <= REG_A;
end 

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      REG_B <= 16'h0000;
    end
  else
    if (SPO[14:8]==7'h43)
      REG_B <= SEL_DAT;
    else
      REG_B <= REG_B;
end 


assign R8_0_HIT =((SPO[14:8]==7'h50)||(SPO[15:8]==8'h70))?1'b1:1'b0;
assign R8_1_HIT =((SPO[14:8]==7'h51)||(SPO[15:8]==8'h70))?1'b1:1'b0;
assign R8_2_HIT =((SPO[14:8]==7'h52)||(SPO[15:8]==8'h71))?1'b1:1'b0;
assign R8_3_HIT =((SPO[14:8]==7'h53)||(SPO[15:8]==8'h71))?1'b1:1'b0;
assign R8_4_HIT =((SPO[14:8]==7'h54)||(SPO[15:8]==8'h72))?1'b1:1'b0;
assign R8_5_HIT =((SPO[14:8]==7'h55)||(SPO[15:8]==8'h72))?1'b1:1'b0;
assign R8_6_HIT =((SPO[14:8]==7'h56)||(SPO[15:8]==8'h73))?1'b1:1'b0;
assign R8_7_HIT =((SPO[14:8]==7'h57)||(SPO[15:8]==8'h73))?1'b1:1'b0;
assign R8_8_HIT =((SPO[14:8]==7'h58)||(SPO[15:8]==8'h74))?1'b1:1'b0;
assign R8_9_HIT =((SPO[14:8]==7'h59)||(SPO[15:8]==8'h74))?1'b1:1'b0;
assign R8_a_HIT =((SPO[14:8]==7'h5a)||(SPO[15:8]==8'h75))?1'b1:1'b0;
assign R8_b_HIT =((SPO[14:8]==7'h5b)||(SPO[15:8]==8'h75))?1'b1:1'b0;
assign R8_c_HIT =((SPO[14:8]==7'h5c)||(SPO[15:8]==8'h76))?1'b1:1'b0;
assign R8_d_HIT =((SPO[14:8]==7'h5d)||(SPO[15:8]==8'h76))?1'b1:1'b0;
assign R8_e_HIT =((SPO[14:8]==7'h5e)||(SPO[15:8]==8'h77))?1'b1:1'b0;
assign R8_f_HIT =((SPO[14:8]==7'h5f)||(SPO[15:8]==8'h77))?1'b1:1'b0;

assign SEL_DAT_H = SEL_DAT16[15:8];
assign SEL_DAT_L = SEL_DAT16[7:0];


REG_UNIT R16_0_REG (
  .CLK(CLK),
  .RST(RST),
  .W_H(R8_1_HIT)    ,.W_L(R8_0_HIT),
  .DA_I_H(SEL_DAT_H),.DA_I_L(SEL_DAT_L),
  .DA_O_H(R8_1)     ,.DA_O_L(R8_0));

REG_UNIT R16_1_REG (
  .CLK(CLK),
  .RST(RST),
  .W_H(R8_3_HIT)    ,.W_L(R8_2_HIT),
  .DA_I_H(SEL_DAT_H),.DA_I_L(SEL_DAT_L),
  .DA_O_H(R8_3)     ,.DA_O_L(R8_2));

REG_UNIT R16_2_REG (
  .CLK(CLK),
  .RST(RST),
  .W_H(R8_5_HIT)    ,.W_L(R8_4_HIT),
  .DA_I_H(SEL_DAT_H),.DA_I_L(SEL_DAT_L),
  .DA_O_H(R8_5)     ,.DA_O_L(R8_4));

REG_UNIT R16_3_REG (
  .CLK(CLK),
  .RST(RST),
  .W_H(R8_7_HIT)    ,.W_L(R8_6_HIT),
  .DA_I_H(SEL_DAT_H),.DA_I_L(SEL_DAT_L),
  .DA_O_H(R8_7)     ,.DA_O_L(R8_6));

REG_UNIT R16_4_REG (
  .CLK(CLK),
  .RST(RST),
  .W_H(R8_9_HIT)    ,.W_L(R8_8_HIT),
  .DA_I_H(SEL_DAT_H),.DA_I_L(SEL_DAT_L),
  .DA_O_H(R8_9)     ,.DA_O_L(R8_8));

REG_UNIT R16_5_REG (
  .CLK(CLK),
  .RST(RST),
  .W_H(R8_b_HIT)    ,.W_L(R8_a_HIT),
  .DA_I_H(SEL_DAT_H),.DA_I_L(SEL_DAT_L),
  .DA_O_H(R8_b)     ,.DA_O_L(R8_a));

REG_UNIT R16_6_REG (
  .CLK(CLK),
  .RST(RST),
  .W_H(R8_d_HIT)    ,.W_L(R8_c_HIT),
  .DA_I_H(SEL_DAT_H),.DA_I_L(SEL_DAT_L),
  .DA_O_H(R8_d)     ,.DA_O_L(R8_c));

REG_UNIT R16_7_REG (
  .CLK(CLK),
  .RST(RST),
  .W_H(R8_f_HIT)    ,.W_L(R8_e_HIT),
  .DA_I_H(SEL_DAT_H),.DA_I_L(SEL_DAT_L),
  .DA_O_H(R8_f)     ,.DA_O_L(R8_e));

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      STS_O <= 8'h00;
    end
  else
    if (SPO[14:8] == 7'h45)
      STS_O <= SEL_DAT;
    else
      STS_O <= STS_O;
end


always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      ST_DO_EN <= 1'b0;
    end
  else
    if ((SPO[15:8]==8'h47)&&(CMD_EN==1'b1))
      begin
        ST_DO_EN <= 1'b1;
      end
    else
      begin
        ST_DO_EN <= 1'b0;
      end
end

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      ST_DO <= 16'h00;
    end
  else
    if (SPO[15:8]==8'h47)
      begin
        ST_DO <= SEL_DAT16;
      end
    else
      begin
        ST_DO <= ST_DO;
      end
end



always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      DMA_MAX <= 16'h00;
    end
  else
    if (SPO[15:8]==8'h4d)
      begin
       DMA_MAX <= SEL_DAT16;
      end
    else
      begin
        DMA_MAX <= DMA_MAX;
      end
end


assign  ST_DI_BUSY = ((SPO[6:0]==7'h46)&&(CMD_EN==1'b1)) ? 1'b0:1'b1;

assign ISA_BASE = 14'h000C; // BASE=300-33f ISA_BASE[13:0]=ADR[19:6]
assign U_DO = U_DAT;

always@(posedge CLK or posedge RST)
begin
  if (RST==1'b1)
    begin
      U_CMD <=  2'b00;
      U_ADR <= 20'h00300;
      U_DAT <= 16'h0000;
      U_START <= 1'b0;
      ISA_DAT <= 16'h00; 
      WAIT_SIG <= 1'b0;
    end
  else
    if ((U_BUSY==1'b0)&&(U_START==1'b0))
      begin
        ISA_DAT <= ISA_DAT;       
        if ((SEL_VAL==1'b0)&&(SPO[7:6]==2'b00)) // ISA read
          begin
            U_CMD <= 2'b01;
            U_ADR <= {ISA_BASE,SPO[5:0]};
            U_DAT <= 16'h00;
            U_START <= 1'b1;
            WAIT_SIG <= 1'b1;
          end
        else
          if (SPO[14]==1'b0) // ISA write
            begin
              U_CMD <= 2'b00;
              U_ADR <= {ISA_BASE,SPO[13:8]} ;
              U_DAT <= SEL_DAT16;
              U_START <= 1'b1;
              WAIT_SIG <= 1'b1;
            end
          else
            begin
              U_CMD <= U_CMD ;
              U_ADR <= U_ADR ;
              U_DAT <= U_DAT;
              U_START <= 1'b0;
              WAIT_SIG <= 1'b0;            
            end
      end 
    else
      begin
        U_CMD <= U_CMD;
        U_ADR <= U_ADR;
        U_DAT <= U_DAT;
        U_START <= 1'b0;
        if (U_END==1'b1)
          begin
            WAIT_SIG <= 1'b0;
            ISA_DAT <=U_DI;
          end
        else
          begin
            WAIT_SIG <= WAIT_SIG;
            ISA_DAT <= ISA_DAT;
          end
      end
end


// program counter monitor
always@(posedge CLK or posedge RST)
begin
if (RST==1'b1)
  MAX_PG <= 8'h00;
else
  if (MAX_PG < PG_CNT)
    MAX_PG <= PG_CNT ;
end

always@(posedge CLK or posedge RST)
begin
if (RST==1'b1)
  ANS_MON <= 8'h00;
else
  if (PG_CNT==8'h3a)
    ANS_MON <= REG_A ;
end

always@(posedge CLK_LED or posedge RST)
begin
  if (RST==1'b1)
    begin
      LED_CNT <= 16'h0000;
      LED_SEL <= 5'b11110;
    end
  else
    begin
      //if (S_BUSY==1'b1)
      //  LED_CNT<=16'h0;
      //else
        LED_CNT <= LED_CNT + 16'h0001;
      if (LED_CNT[7:0]==8'hff)
        LED_SEL <= {LED_SEL[3:0],LED_SEL[4]};
      else
        LED_SEL <= LED_SEL;
    end
end

function [7:0] SEG_DEC;
input [3:0]IN_DATA;
begin
      case (IN_DATA)
         4'b0000: SEG_DEC=8'b00111111;
         4'b0001: SEG_DEC=8'b00000110;
         4'b0010: SEG_DEC=8'b01011011;
         4'b0011: SEG_DEC=8'b01001111;
         4'b0100: SEG_DEC=8'b01100110;
         4'b0101: SEG_DEC=8'b01101101;
         4'b0110: SEG_DEC=8'b01111101;
         4'b0111: SEG_DEC=8'b00100111;
         4'b1000: SEG_DEC=8'b01111111; //8
         4'b1001: SEG_DEC=8'b01100111; //9
         4'b1010: SEG_DEC=8'b01110111; //A
         4'b1011: SEG_DEC=8'b01111100; //b
         4'b1100: SEG_DEC=8'b00111001; //c
         4'b1101: SEG_DEC=8'b01011110; //d
         4'b1110: SEG_DEC=8'b01111001; //e
         4'b1111: SEG_DEC=8'b01110001; //f
         default: SEG_DEC=8'b00000000;
       endcase
end
endfunction
 
//assign LED  =PG_CNT;
assign LED={TCP_SW==1'b0}?8'h00:8'hff;
assign SEG_TMP = {R8_f,HTTP_CNT2,HTTP_CNT1}; //REG_A;

assign SEG3 =SEG_DEC(SEG_TMP[3:0]);
assign SEG2 =SEG_DEC(SEG_TMP[7:4]);
assign SEG1 =SEG_DEC(SEG_TMP[11:8]);
assign SEG0 =SEG_DEC(SEG_TMP[15:12]);

assign PRC_LED = (LED_SEL[0]==1'b0)? SEG0:
                 (LED_SEL[1]==1'b0)? SEG1:
                 (LED_SEL[2]==1'b0)? SEG2:
                 (LED_SEL[3]==1'b0)? SEG3:
                                     LED;

// monitor
// honmono
/*
always@(posedge CLK_LED or posedge RST)
begin
  if (RST==1'b1)
    begin  
		SEND_DT_1 <= 8'h00;
		SEND_DT_2 <= 8'h00;
		SEND_DT_3 <= 8'h00;
		SEND_DT_4 <= 8'h00;
    end
  else
	 if(CMD_EN==1'b1)
      begin 
		  SEND_DT_1 <= PG_CNT;
		  SEND_DT_2 <= R8_0;//REG_A;
		  SEND_DT_3 <= SEL_DAT16[15:8];
		  SEND_DT_4 <= SEL_DAT16[7:0];
      end
end
*/
/*
always@(posedge CLK_LED or posedge RST)
begin
  if (RST==1'b1)
    begin
      SEND <= 1'b0;
      SEND_CASE<=5'h00; 
		SEND_DT <= 8'h00;
    end
  else
    case(SEND_CASE)
    5'h00:
      begin
        if (PG_CNT>=8'h01)
          begin
            if ((S_BUSY==1'b0)&&(CMD_EN==1'b1)&&(CLK==1'b1)&&(SEND==1'b0))
              begin
                SEND <= 1'b1;
					 SEND_DT <= 8'hff;
              end
            else
              begin
                SEND <= 1'b0; 
					 SEND_DT <= SEND_DT ;
              end 
            if (SEND==1'b1)
              SEND_CASE <= 5'h01;
          end
        else
          begin
            SEND <= 1'b0;
	    		SEND_DT <= SEND_DT ;
            SEND_CASE <= 5'h00;
          end
      end
    5'h01:
      begin
        if ((S_BUSY==1'b0)&&(SEND==1'b0)&&(LED_CNT[7:0]==8'hff))
          begin
            SEND <= 1'b1; 
	         SEND_DT <= SEND_DT_1 ;
          end
        else
          begin
            SEND <= 1'b0;
	         SEND_DT <= SEND_DT ;
          end 
        if (SEND==1'b1)
          SEND_CASE <= 5'h02; 
      end
    5'h02:
      begin
        if ((S_BUSY==1'b0)&&(SEND==1'b0)&&(LED_CNT[7:0]==8'hff))
          begin
            SEND <= 1'b1;
	         SEND_DT <= SEND_DT_2 ;
          end
        else
          begin
            SEND <= 1'b0;
	         SEND_DT <= SEND_DT ;
          end 
        if (SEND==1'b1)
          SEND_CASE <= 5'h03;
      end
    5'h03:
      begin
        if ((S_BUSY==1'b0)&&(SEND==1'b0)&&(LED_CNT[7:0]==8'hff))
          begin
            SEND <= 1'b1;
	         SEND_DT <= SEND_DT_3 ;
          end
        else
          begin
            SEND <= 1'b0;
	         SEND_DT <= SEND_DT ;
          end 
        if (SEND==1'b1)
          SEND_CASE <= 5'h04;
      end
    5'h04:
      begin
        if ((S_BUSY==1'b0)&&(SEND==1'b0)&&(LED_CNT[7:0]==8'hff))
          begin
            SEND <= 1'b1;
	         SEND_DT <= SEND_DT_4 ;
          end
        else
          begin
            SEND <= 1'b0;
		      SEND_DT <= SEND_DT ;
          end 
        if (SEND==1'b1)
          SEND_CASE <= 5'h05; 
      end
    5'h05:
      begin
        SEND <= 1'b0;
		  SEND_DT <= SEND_DT ;
        if (CLK==1'b0)
            SEND_CASE <= 5'h00;
        else
            SEND_CASE <= 5'h05;
      end
	 
    default:
      begin
        SEND <= 1'b0;
        SEND_CASE <= 5'h00;
   	  SEND_DT <= SEND_DT ;
      end
    endcase
end
*/

c_rom c_rom_1 (
	.A(PG_CNT),
	.SPO(SPO));

endmodule















