//module:IP_EXT 
//Ver 0.50
//date 20/01/2003
//Kenji Yokomizo <kyokomi@mvi.biglobe.ne.jp>
//

module  USER_BLK (CLK,XRST,
                DATA_IN,DATA_IN_EN,
                DATA_OUT,DATA_OUT_EN,    
                TCP_SW);

input   CLK,XRST;
input   DATA_OUT;
input   DATA_OUT_EN;
output  [7:0]DATA_IN;
output  DATA_IN_EN;
output  TCP_SW;


reg TCP_SW;
reg DATA_IN_EN;
//wire DATA_IN_EN;
reg [3:0]HTTP_CNT1;
reg [3:0]HTTP_CNT2;
wire [7:0]DATA_IN;
//*** user_block ***


always@(posedge CLK or negedge XRST)
begin
  if (XRST==1'b0)
    begin
      TCP_SW <= 1'b0;
    end
  else
    if (DATA_OUT_EN==1'b1)
      TCP_SW <= DATA_OUT;
    else
      TCP_SW <= TCP_SW;
end


always@(posedge CLK or negedge XRST)
begin
  if (XRST==1'b0)
    begin
      HTTP_CNT1<= 4'h0;
      HTTP_CNT2<= 4'h0;
      DATA_IN_EN <= 1'b0;
    end
  else
    if (DATA_OUT_EN==1'b1)
      begin
        DATA_IN_EN <= 1'b1;
        if (HTTP_CNT1==4'h9)
          begin
            HTTP_CNT1 <= 4'h0;
            if (HTTP_CNT2==4'h9)
              HTTP_CNT2 <= 4'h0;
            else
              HTTP_CNT2 <= HTTP_CNT2 +8'h01;
          end
        else
          begin
            HTTP_CNT1 <= HTTP_CNT1 +8'h01;
            HTTP_CNT2 <= HTTP_CNT2 ;
          end
      end
    else     
      begin
        DATA_IN_EN <= 1'b0;
        HTTP_CNT1 <= HTTP_CNT1 ;
        HTTP_CNT2 <= HTTP_CNT2 ;
      end
end

assign DATA_IN = {HTTP_CNT2,HTTP_CNT1};


//assign DATA_IN = 8'h55;
//assign DATA_IN_EN = 1'b1;

endmodule















